//-----------------------------------------------------------------------
// class INetworkUser
//
// Network user interface
//
// Author:  Sylvain Lefebvre
// History: Created 04/04/2002
//-----------------------------------------------------------------------
#ifndef __INETWORKUSER__
#define __INETWORKUSER__
//-----------------------------------------------------------------------
#define NU_TMOUT 30000
//-----------------------------------------------------------------------
#include "CNetwork.h"
//-----------------------------------------------------------------------
class INetworkUser
{
protected:

  CNetwork *m_Ntwrk;
 
  virtual void processServerMessage(const network_msg&)=0;
  virtual void processClientMessage(const network_msg&)=0;
  virtual void onNetworkReady()=0;
  virtual void onClientConnection(int)=0;
  virtual void onClientDisconnection(int)=0;

  friend class CNetwork;

public:
           INetworkUser();
  virtual ~INetworkUser() {}

  bool         isNetworkRunning() {return (m_Ntwrk != NULL && m_Ntwrk->isEnabled());}
  virtual void waitForNetworkReady();
  
};
//-----------------------------------------------------------------------
#endif
//-----------------------------------------------------------------------
// ---------------------------------------------------------- 
// Sylvain Lefebvre - (c) 2002 - Sylvain.Lefebvre@laposte.net
// ----------------------------------------------------------
