/* $ANTLR 2.7.3rc2: "calc.g" -> "CalcParser.cpp"$ */
#line 11 "calc.g"

#include "CException.h"
#include "MyASTNode.h" // $FAB
#include "CMobile.h"
#include "CWorld.h"
#include "messages_calc.h"

extern int cur_line;
extern int cur_mob;
#define getCurLine() (cur_line+1) 
#define warning(msg) display_warning(msg,m_Mobile_id+1,getCurLine())
    
#define ME            	        -1
#define MOUSE          		-2
#define COLLIDER       		-3
#define PREV           		-4
#define NEXT       	    	-5
#define NEAREST        		-6
#define NEAREST2       		-7
#define NEAREST3       		-8
#define NEAREST_LEFT   		-9
#define NEAREST_RIGHT 	       -10
#define NEAREST_UP    	       -11
#define NEAREST_DOWN  	       -12
#define EMPTY         	       -13
#define NEAREST_INDIR 	       -14
#define NEAREST_INDIR2 	       -15
#define NEAREST_INDIR3	       -16
#define CAMERA                 -17
#define LIGHT1                 -18
#define LIGHT2                 -19
#define LIGHT3                 -20

// flags pour get*Ptr()
#define MOVEABLE               0x01
#define NOT_PSEUDOMOBILES      0x02
#define NOT_ME                 0x04
#define NOT_ME_IF_START      ( (field==FIELD_START)?NOT_ME:0 )

// flags pour get*Ref()
#define CREATE_ON_FAIL 0x01
#define MUST_EXIST     0x02

// macros utiles
#define is_local(ib) ( ((ib) == -1) || ((ib)-1 == m_Mobile_client_id) )

#define is_me(ia,ib) ( is_local(ib) &&      \
          ( ( (ia) == -1) || ( (ia)-1 == m_Mobile_id ) )    )

#define conv_ref_to_number(mob) (                       \
   ( is_local((mob).client) && ((mob).mobile>-1) )      \
        ? (mob).mobile                                  \
        : WORLD.getMobileLocalId(getMobilePtr(mob))  )


#define RED     "4278190080" // 0xff000000
#define GREEN     "16711680" // 0x00ff0000
#define BLUE         "65280" // 0x0000ff00
#define YELLOW  "4294901760" // 0xffff0000
#define CYAN      "16776960" // 0x00ffff00
#define PURPLE  "4278255360" // 0xff00ff00
#define WHITE   "4294967040" // 0xffffff00
#define BLACK            "0" // 0x00000000
#define GRAY    "2155905024" // 0x80808000
#define ORANGE  "4287102976" // 0xff880000

#line 70 "CalcParser.cpp"
#include "CalcParser.hpp"
#include <antlr/NoViableAltException.hpp>
#include <antlr/SemanticException.hpp>
#include <antlr/ASTFactory.hpp>
#line 1 "calc.g"
#line 76 "CalcParser.cpp"
CalcParser::CalcParser(ANTLR_USE_NAMESPACE(antlr)TokenBuffer& tokenBuf, int k)
: ANTLR_USE_NAMESPACE(antlr)LLkParser(tokenBuf,k)
{
}

CalcParser::CalcParser(ANTLR_USE_NAMESPACE(antlr)TokenBuffer& tokenBuf)
: ANTLR_USE_NAMESPACE(antlr)LLkParser(tokenBuf,1)
{
}

CalcParser::CalcParser(ANTLR_USE_NAMESPACE(antlr)TokenStream& lexer, int k)
: ANTLR_USE_NAMESPACE(antlr)LLkParser(lexer,k)
{
}

CalcParser::CalcParser(ANTLR_USE_NAMESPACE(antlr)TokenStream& lexer)
: ANTLR_USE_NAMESPACE(antlr)LLkParser(lexer,1)
{
}

CalcParser::CalcParser(const ANTLR_USE_NAMESPACE(antlr)ParserSharedInputState& state)
: ANTLR_USE_NAMESPACE(antlr)LLkParser(state,1)
{
}

void CalcParser::start() {
	returnAST = ANTLR_USE_NAMESPACE(antlr)nullAST;
	ANTLR_USE_NAMESPACE(antlr)ASTPair currentAST;
	ANTLR_USE_NAMESPACE(antlr)RefAST start_AST = ANTLR_USE_NAMESPACE(antlr)nullAST;
	
	{ // ( ... )*
	for (;;) {
		if ((_tokenSet_0.member(LA(1)))) {
			{
			switch ( LA(1)) {
			case LITERAL_if:
			case LITERAL_stop:
			case LITERAL_start:
			case LITERAL_restart:
			case LITERAL_like:
			case LITERAL_move_to:
			case LITERAL_echo:
			case ID:
			case LITERAL_trace:
			case LITERAL_x:
			case LITERAL_y:
			case LITERAL_dx:
			case LITERAL_dy:
			case LITERAL_angle:
			case LITERAL_icon:
			case LITERAL_color:
			case LITERAL_red:
			case LITERAL_green:
			case LITERAL_blue:
			case LITERAL_gray:
			case LITERAL_shockx:
			case LITERAL_shocky:
			case LITERAL_width:
			case LITERAL_height:
			case LITERAL_zoom:
			case LITERAL_visible:
			case LITERAL_contact:
			case LITERAL_mem:
			{
				expr();
				if (inputState->guessing==0) {
					astFactory->addASTChild( currentAST, returnAST );
				}
				break;
			}
			case NEWLINE:
			case SEMI:
			{
				break;
			}
			default:
			{
				throw ANTLR_USE_NAMESPACE(antlr)NoViableAltException(LT(1), getFilename());
			}
			}
			}
			{
			switch ( LA(1)) {
			case NEWLINE:
			{
				match(NEWLINE);
				break;
			}
			case SEMI:
			{
				match(SEMI);
				break;
			}
			default:
			{
				throw ANTLR_USE_NAMESPACE(antlr)NoViableAltException(LT(1), getFilename());
			}
			}
			}
		}
		else {
			goto _loop177;
		}
		
	}
	_loop177:;
	} // ( ... )*
	start_AST = currentAST.root;
	returnAST = start_AST;
}

void CalcParser::expr() {
	returnAST = ANTLR_USE_NAMESPACE(antlr)nullAST;
	ANTLR_USE_NAMESPACE(antlr)ASTPair currentAST;
	ANTLR_USE_NAMESPACE(antlr)RefAST expr_AST = ANTLR_USE_NAMESPACE(antlr)nullAST;
	
	switch ( LA(1)) {
	case LITERAL_if:
	{
		ANTLR_USE_NAMESPACE(antlr)RefAST tmp146_AST = ANTLR_USE_NAMESPACE(antlr)nullAST;
		if ( inputState->guessing == 0 ) {
			tmp146_AST = astFactory->create(LT(1));
			astFactory->makeASTRoot(currentAST, tmp146_AST);
		}
		match(LITERAL_if);
		fexpr();
		if (inputState->guessing==0) {
			astFactory->addASTChild( currentAST, returnAST );
		}
		match(LITERAL_then);
		isolated_start();
		if (inputState->guessing==0) {
			astFactory->addASTChild( currentAST, returnAST );
		}
		{
		switch ( LA(1)) {
		case LITERAL_else:
		{
			match(LITERAL_else);
			start();
			if (inputState->guessing==0) {
				astFactory->addASTChild( currentAST, returnAST );
			}
			break;
		}
		case LITERAL_endif:
		{
			break;
		}
		default:
		{
			throw ANTLR_USE_NAMESPACE(antlr)NoViableAltException(LT(1), getFilename());
		}
		}
		}
		match(LITERAL_endif);
		expr_AST = currentAST.root;
		break;
	}
	case LITERAL_stop:
	{
		ANTLR_USE_NAMESPACE(antlr)RefAST tmp150_AST = ANTLR_USE_NAMESPACE(antlr)nullAST;
		if ( inputState->guessing == 0 ) {
			tmp150_AST = astFactory->create(LT(1));
			astFactory->makeASTRoot(currentAST, tmp150_AST);
		}
		match(LITERAL_stop);
		ref();
		if (inputState->guessing==0) {
			astFactory->addASTChild( currentAST, returnAST );
		}
		expr_AST = currentAST.root;
		break;
	}
	case LITERAL_start:
	{
		ANTLR_USE_NAMESPACE(antlr)RefAST tmp151_AST = ANTLR_USE_NAMESPACE(antlr)nullAST;
		if ( inputState->guessing == 0 ) {
			tmp151_AST = astFactory->create(LT(1));
			astFactory->makeASTRoot(currentAST, tmp151_AST);
		}
		match(LITERAL_start);
		ref();
		if (inputState->guessing==0) {
			astFactory->addASTChild( currentAST, returnAST );
		}
		expr_AST = currentAST.root;
		break;
	}
	case LITERAL_restart:
	{
		ANTLR_USE_NAMESPACE(antlr)RefAST tmp152_AST = ANTLR_USE_NAMESPACE(antlr)nullAST;
		if ( inputState->guessing == 0 ) {
			tmp152_AST = astFactory->create(LT(1));
			astFactory->makeASTRoot(currentAST, tmp152_AST);
		}
		match(LITERAL_restart);
		ref();
		if (inputState->guessing==0) {
			astFactory->addASTChild( currentAST, returnAST );
		}
		expr_AST = currentAST.root;
		break;
	}
	case LITERAL_like:
	{
		ANTLR_USE_NAMESPACE(antlr)RefAST tmp153_AST = ANTLR_USE_NAMESPACE(antlr)nullAST;
		if ( inputState->guessing == 0 ) {
			tmp153_AST = astFactory->create(LT(1));
			astFactory->makeASTRoot(currentAST, tmp153_AST);
		}
		match(LITERAL_like);
		localref();
		if (inputState->guessing==0) {
			astFactory->addASTChild( currentAST, returnAST );
		}
		expr_AST = currentAST.root;
		break;
	}
	case LITERAL_move_to:
	{
		ANTLR_USE_NAMESPACE(antlr)RefAST tmp154_AST = ANTLR_USE_NAMESPACE(antlr)nullAST;
		if ( inputState->guessing == 0 ) {
			tmp154_AST = astFactory->create(LT(1));
			astFactory->makeASTRoot(currentAST, tmp154_AST);
		}
		match(LITERAL_move_to);
		match(LPAREN);
		ref();
		if (inputState->guessing==0) {
			astFactory->addASTChild( currentAST, returnAST );
		}
		match(COMMA);
		fexpr();
		if (inputState->guessing==0) {
			astFactory->addASTChild( currentAST, returnAST );
		}
		match(COMMA);
		fexpr();
		if (inputState->guessing==0) {
			astFactory->addASTChild( currentAST, returnAST );
		}
		match(RPAREN);
		expr_AST = currentAST.root;
		break;
	}
	case LITERAL_trace:
	{
		ANTLR_USE_NAMESPACE(antlr)RefAST tmp159_AST = ANTLR_USE_NAMESPACE(antlr)nullAST;
		if ( inputState->guessing == 0 ) {
			tmp159_AST = astFactory->create(LT(1));
			astFactory->addASTChild(currentAST, tmp159_AST);
		}
		match(LITERAL_trace);
		ANTLR_USE_NAMESPACE(antlr)RefAST tmp160_AST = ANTLR_USE_NAMESPACE(antlr)nullAST;
		if ( inputState->guessing == 0 ) {
			tmp160_AST = astFactory->create(LT(1));
			astFactory->makeASTRoot(currentAST, tmp160_AST);
		}
		match(COLON);
		fexpr();
		if (inputState->guessing==0) {
			astFactory->addASTChild( currentAST, returnAST );
		}
		expr_AST = currentAST.root;
		break;
	}
	case LITERAL_echo:
	{
		ANTLR_USE_NAMESPACE(antlr)RefAST tmp161_AST = ANTLR_USE_NAMESPACE(antlr)nullAST;
		if ( inputState->guessing == 0 ) {
			tmp161_AST = astFactory->create(LT(1));
			astFactory->makeASTRoot(currentAST, tmp161_AST);
		}
		match(LITERAL_echo);
		ANTLR_USE_NAMESPACE(antlr)RefAST tmp162_AST = ANTLR_USE_NAMESPACE(antlr)nullAST;
		if ( inputState->guessing == 0 ) {
			tmp162_AST = astFactory->create(LT(1));
			astFactory->addASTChild(currentAST, tmp162_AST);
		}
		match(ID);
		expr_AST = currentAST.root;
		break;
	}
	default:
		bool synPredMatched181 = false;
		if (((LA(1) == ID))) {
			int _m181 = mark();
			synPredMatched181 = true;
			inputState->guessing++;
			try {
				{
				match(ID);
				match(COLON);
				fullref();
				}
			}
			catch (ANTLR_USE_NAMESPACE(antlr)RecognitionException& pe) {
				synPredMatched181 = false;
			}
			rewind(_m181);
			inputState->guessing--;
		}
		if ( synPredMatched181 ) {
			ANTLR_USE_NAMESPACE(antlr)RefAST tmp163_AST = ANTLR_USE_NAMESPACE(antlr)nullAST;
			if ( inputState->guessing == 0 ) {
				tmp163_AST = astFactory->create(LT(1));
				astFactory->addASTChild(currentAST, tmp163_AST);
			}
			match(ID);
			ANTLR_USE_NAMESPACE(antlr)RefAST tmp164_AST = ANTLR_USE_NAMESPACE(antlr)nullAST;
			if ( inputState->guessing == 0 ) {
				tmp164_AST = astFactory->create(LT(1));
				astFactory->makeASTRoot(currentAST, tmp164_AST);
			}
			match(COLON);
			fullref();
			if (inputState->guessing==0) {
				astFactory->addASTChild( currentAST, returnAST );
			}
			expr_AST = currentAST.root;
		}
		else {
			bool synPredMatched183 = false;
			if (((_tokenSet_1.member(LA(1))))) {
				int _m183 = mark();
				synPredMatched183 = true;
				inputState->guessing++;
				try {
					{
					lvalue();
					match(COLON);
					fexpr();
					}
				}
				catch (ANTLR_USE_NAMESPACE(antlr)RecognitionException& pe) {
					synPredMatched183 = false;
				}
				rewind(_m183);
				inputState->guessing--;
			}
			if ( synPredMatched183 ) {
				lvalue();
				if (inputState->guessing==0) {
					astFactory->addASTChild( currentAST, returnAST );
				}
				ANTLR_USE_NAMESPACE(antlr)RefAST tmp165_AST = ANTLR_USE_NAMESPACE(antlr)nullAST;
				if ( inputState->guessing == 0 ) {
					tmp165_AST = astFactory->create(LT(1));
					astFactory->makeASTRoot(currentAST, tmp165_AST);
				}
				match(COLON);
				fexpr();
				if (inputState->guessing==0) {
					astFactory->addASTChild( currentAST, returnAST );
				}
				expr_AST = currentAST.root;
			}
			else if ((_tokenSet_1.member(LA(1)))) {
				lvalue();
				if (inputState->guessing==0) {
					astFactory->addASTChild( currentAST, returnAST );
				}
				ANTLR_USE_NAMESPACE(antlr)RefAST tmp166_AST = ANTLR_USE_NAMESPACE(antlr)nullAST;
				if ( inputState->guessing == 0 ) {
					tmp166_AST = astFactory->create(LT(1));
					astFactory->makeASTRoot(currentAST, tmp166_AST);
				}
				match(COLON);
				ref();
				if (inputState->guessing==0) {
					astFactory->addASTChild( currentAST, returnAST );
				}
				expr_AST = currentAST.root;
			}
	else {
		throw ANTLR_USE_NAMESPACE(antlr)NoViableAltException(LT(1), getFilename());
	}
	}}
	returnAST = expr_AST;
}

void CalcParser::isolated_start() {
	returnAST = ANTLR_USE_NAMESPACE(antlr)nullAST;
	ANTLR_USE_NAMESPACE(antlr)ASTPair currentAST;
	ANTLR_USE_NAMESPACE(antlr)RefAST isolated_start_AST = ANTLR_USE_NAMESPACE(antlr)nullAST;
	ANTLR_USE_NAMESPACE(antlr)RefAST a_AST = ANTLR_USE_NAMESPACE(antlr)nullAST;
	
	start();
	if (inputState->guessing==0) {
		a_AST = returnAST;
		astFactory->addASTChild( currentAST, returnAST );
	}
	if ( inputState->guessing==0 ) {
		isolated_start_AST = ANTLR_USE_NAMESPACE(antlr)RefAST(currentAST.root);
#line 960 "calc.g"
		isolated_start_AST = ANTLR_USE_NAMESPACE(antlr)RefAST(astFactory->make((new ANTLR_USE_NAMESPACE(antlr)ASTArray(2))->add(astFactory->create(REF,"BIDON"))->add(a_AST)));
#line 474 "CalcParser.cpp"
		currentAST.root = isolated_start_AST;
		if ( isolated_start_AST!=ANTLR_USE_NAMESPACE(antlr)nullAST &&
			isolated_start_AST->getFirstChild() != ANTLR_USE_NAMESPACE(antlr)nullAST )
			  currentAST.child = isolated_start_AST->getFirstChild();
		else
			currentAST.child = isolated_start_AST;
		currentAST.advanceChildToEnd();
	}
	isolated_start_AST = currentAST.root;
	returnAST = isolated_start_AST;
}

void CalcParser::fullref() {
	returnAST = ANTLR_USE_NAMESPACE(antlr)nullAST;
	ANTLR_USE_NAMESPACE(antlr)ASTPair currentAST;
	ANTLR_USE_NAMESPACE(antlr)RefAST fullref_AST = ANTLR_USE_NAMESPACE(antlr)nullAST;
	ANTLR_USE_NAMESPACE(antlr)RefToken  i = ANTLR_USE_NAMESPACE(antlr)nullToken;
	ANTLR_USE_NAMESPACE(antlr)RefAST i_AST = ANTLR_USE_NAMESPACE(antlr)nullAST;
	ANTLR_USE_NAMESPACE(antlr)RefToken  j = ANTLR_USE_NAMESPACE(antlr)nullToken;
	ANTLR_USE_NAMESPACE(antlr)RefAST j_AST = ANTLR_USE_NAMESPACE(antlr)nullAST;
	ANTLR_USE_NAMESPACE(antlr)RefAST dx_AST = ANTLR_USE_NAMESPACE(antlr)nullAST;
	ANTLR_USE_NAMESPACE(antlr)RefAST dy_AST = ANTLR_USE_NAMESPACE(antlr)nullAST;
	ANTLR_USE_NAMESPACE(antlr)RefAST ang_AST = ANTLR_USE_NAMESPACE(antlr)nullAST;
	ANTLR_USE_NAMESPACE(antlr)RefAST dxA_AST = ANTLR_USE_NAMESPACE(antlr)nullAST;
	ANTLR_USE_NAMESPACE(antlr)RefAST dyA_AST = ANTLR_USE_NAMESPACE(antlr)nullAST;
	ANTLR_USE_NAMESPACE(antlr)RefAST angA_AST = ANTLR_USE_NAMESPACE(antlr)nullAST;
	ANTLR_USE_NAMESPACE(antlr)RefAST dxB_AST = ANTLR_USE_NAMESPACE(antlr)nullAST;
	ANTLR_USE_NAMESPACE(antlr)RefAST dyB_AST = ANTLR_USE_NAMESPACE(antlr)nullAST;
	ANTLR_USE_NAMESPACE(antlr)RefAST angB_AST = ANTLR_USE_NAMESPACE(antlr)nullAST;
	
	switch ( LA(1)) {
	case INT:
	{
		{
		i = LT(1);
		if ( inputState->guessing == 0 ) {
			i_AST = astFactory->create(i);
		}
		match(INT);
		ANTLR_USE_NAMESPACE(antlr)RefAST tmp167_AST = ANTLR_USE_NAMESPACE(antlr)nullAST;
		if ( inputState->guessing == 0 ) {
			tmp167_AST = astFactory->create(LT(1));
		}
		match(AT);
		j = LT(1);
		if ( inputState->guessing == 0 ) {
			j_AST = astFactory->create(j);
		}
		match(INT);
		}
		if ( inputState->guessing==0 ) {
			fullref_AST = ANTLR_USE_NAMESPACE(antlr)RefAST(currentAST.root);
#line 1020 "calc.g"
			fullref_AST = ANTLR_USE_NAMESPACE(antlr)RefAST(astFactory->make((new ANTLR_USE_NAMESPACE(antlr)ASTArray(5))->add(astFactory->create(REF,"REF"))->add(i_AST)->add(j_AST)->add(astFactory->create(INT,"-1"))->add(astFactory->create(INT,"-1"))));
#line 529 "CalcParser.cpp"
			currentAST.root = fullref_AST;
			if ( fullref_AST!=ANTLR_USE_NAMESPACE(antlr)nullAST &&
				fullref_AST->getFirstChild() != ANTLR_USE_NAMESPACE(antlr)nullAST )
				  currentAST.child = fullref_AST->getFirstChild();
			else
				currentAST.child = fullref_AST;
			currentAST.advanceChildToEnd();
		}
		break;
	}
	case LITERAL_me:
	{
		match(LITERAL_me);
		if ( inputState->guessing==0 ) {
			fullref_AST = ANTLR_USE_NAMESPACE(antlr)RefAST(currentAST.root);
#line 1022 "calc.g"
			fullref_AST = ANTLR_USE_NAMESPACE(antlr)RefAST(astFactory->make((new ANTLR_USE_NAMESPACE(antlr)ASTArray(5))->add(astFactory->create(REF,"REF"))->add(astFactory->create(INT,"-1"))->add(astFactory->create(INT,"-1"))->add(astFactory->create(INT,"-1"))->add(astFactory->create(INT,"-1"))));
#line 547 "CalcParser.cpp"
			currentAST.root = fullref_AST;
			if ( fullref_AST!=ANTLR_USE_NAMESPACE(antlr)nullAST &&
				fullref_AST->getFirstChild() != ANTLR_USE_NAMESPACE(antlr)nullAST )
				  currentAST.child = fullref_AST->getFirstChild();
			else
				currentAST.child = fullref_AST;
			currentAST.advanceChildToEnd();
		}
		break;
	}
	case LITERAL_mouse:
	{
		match(LITERAL_mouse);
		if ( inputState->guessing==0 ) {
			fullref_AST = ANTLR_USE_NAMESPACE(antlr)RefAST(currentAST.root);
#line 1024 "calc.g"
			fullref_AST = ANTLR_USE_NAMESPACE(antlr)RefAST(astFactory->make((new ANTLR_USE_NAMESPACE(antlr)ASTArray(5))->add(astFactory->create(REF,"REF"))->add(astFactory->create(INT,"-2"))->add(astFactory->create(INT,"-1"))->add(astFactory->create(INT,"-1"))->add(astFactory->create(INT,"-1"))));
#line 565 "CalcParser.cpp"
			currentAST.root = fullref_AST;
			if ( fullref_AST!=ANTLR_USE_NAMESPACE(antlr)nullAST &&
				fullref_AST->getFirstChild() != ANTLR_USE_NAMESPACE(antlr)nullAST )
				  currentAST.child = fullref_AST->getFirstChild();
			else
				currentAST.child = fullref_AST;
			currentAST.advanceChildToEnd();
		}
		break;
	}
	case LITERAL_collider:
	{
		{
		match(LITERAL_collider);
		}
		if ( inputState->guessing==0 ) {
			fullref_AST = ANTLR_USE_NAMESPACE(antlr)RefAST(currentAST.root);
#line 1026 "calc.g"
			fullref_AST = ANTLR_USE_NAMESPACE(antlr)RefAST(astFactory->make((new ANTLR_USE_NAMESPACE(antlr)ASTArray(5))->add(astFactory->create(REF,"REF"))->add(astFactory->create(INT,"-3"))->add(astFactory->create(INT,"-1"))->add(astFactory->create(INT,"-1"))->add(astFactory->create(INT,"-1"))));
#line 585 "CalcParser.cpp"
			currentAST.root = fullref_AST;
			if ( fullref_AST!=ANTLR_USE_NAMESPACE(antlr)nullAST &&
				fullref_AST->getFirstChild() != ANTLR_USE_NAMESPACE(antlr)nullAST )
				  currentAST.child = fullref_AST->getFirstChild();
			else
				currentAST.child = fullref_AST;
			currentAST.advanceChildToEnd();
		}
		break;
	}
	case LITERAL_prev:
	{
		match(LITERAL_prev);
		if ( inputState->guessing==0 ) {
			fullref_AST = ANTLR_USE_NAMESPACE(antlr)RefAST(currentAST.root);
#line 1028 "calc.g"
			fullref_AST = ANTLR_USE_NAMESPACE(antlr)RefAST(astFactory->make((new ANTLR_USE_NAMESPACE(antlr)ASTArray(5))->add(astFactory->create(REF,"REF"))->add(astFactory->create(INT,"-4"))->add(astFactory->create(INT,"-1"))->add(astFactory->create(INT,"-1"))->add(astFactory->create(INT,"-1"))));
#line 603 "CalcParser.cpp"
			currentAST.root = fullref_AST;
			if ( fullref_AST!=ANTLR_USE_NAMESPACE(antlr)nullAST &&
				fullref_AST->getFirstChild() != ANTLR_USE_NAMESPACE(antlr)nullAST )
				  currentAST.child = fullref_AST->getFirstChild();
			else
				currentAST.child = fullref_AST;
			currentAST.advanceChildToEnd();
		}
		break;
	}
	case LITERAL_next:
	{
		match(LITERAL_next);
		if ( inputState->guessing==0 ) {
			fullref_AST = ANTLR_USE_NAMESPACE(antlr)RefAST(currentAST.root);
#line 1030 "calc.g"
			fullref_AST = ANTLR_USE_NAMESPACE(antlr)RefAST(astFactory->make((new ANTLR_USE_NAMESPACE(antlr)ASTArray(5))->add(astFactory->create(REF,"REF"))->add(astFactory->create(INT,"-5"))->add(astFactory->create(INT,"-1"))->add(astFactory->create(INT,"-1"))->add(astFactory->create(INT,"-1"))));
#line 621 "CalcParser.cpp"
			currentAST.root = fullref_AST;
			if ( fullref_AST!=ANTLR_USE_NAMESPACE(antlr)nullAST &&
				fullref_AST->getFirstChild() != ANTLR_USE_NAMESPACE(antlr)nullAST )
				  currentAST.child = fullref_AST->getFirstChild();
			else
				currentAST.child = fullref_AST;
			currentAST.advanceChildToEnd();
		}
		break;
	}
	case LITERAL_nearest:
	{
		match(LITERAL_nearest);
		if ( inputState->guessing==0 ) {
			fullref_AST = ANTLR_USE_NAMESPACE(antlr)RefAST(currentAST.root);
#line 1032 "calc.g"
			fullref_AST = ANTLR_USE_NAMESPACE(antlr)RefAST(astFactory->make((new ANTLR_USE_NAMESPACE(antlr)ASTArray(5))->add(astFactory->create(REF,"REF"))->add(astFactory->create(INT,"-6"))->add(astFactory->create(INT,"-1"))->add(astFactory->create(INT,"-1"))->add(astFactory->create(INT,"-1"))));
#line 639 "CalcParser.cpp"
			currentAST.root = fullref_AST;
			if ( fullref_AST!=ANTLR_USE_NAMESPACE(antlr)nullAST &&
				fullref_AST->getFirstChild() != ANTLR_USE_NAMESPACE(antlr)nullAST )
				  currentAST.child = fullref_AST->getFirstChild();
			else
				currentAST.child = fullref_AST;
			currentAST.advanceChildToEnd();
		}
		break;
	}
	case LITERAL_nearest_second:
	{
		match(LITERAL_nearest_second);
		if ( inputState->guessing==0 ) {
			fullref_AST = ANTLR_USE_NAMESPACE(antlr)RefAST(currentAST.root);
#line 1034 "calc.g"
			fullref_AST = ANTLR_USE_NAMESPACE(antlr)RefAST(astFactory->make((new ANTLR_USE_NAMESPACE(antlr)ASTArray(5))->add(astFactory->create(REF,"REF"))->add(astFactory->create(INT,"-7"))->add(astFactory->create(INT,"-1"))->add(astFactory->create(INT,"-1"))->add(astFactory->create(INT,"-1"))));
#line 657 "CalcParser.cpp"
			currentAST.root = fullref_AST;
			if ( fullref_AST!=ANTLR_USE_NAMESPACE(antlr)nullAST &&
				fullref_AST->getFirstChild() != ANTLR_USE_NAMESPACE(antlr)nullAST )
				  currentAST.child = fullref_AST->getFirstChild();
			else
				currentAST.child = fullref_AST;
			currentAST.advanceChildToEnd();
		}
		break;
	}
	case LITERAL_nearest_third:
	{
		match(LITERAL_nearest_third);
		if ( inputState->guessing==0 ) {
			fullref_AST = ANTLR_USE_NAMESPACE(antlr)RefAST(currentAST.root);
#line 1036 "calc.g"
			fullref_AST = ANTLR_USE_NAMESPACE(antlr)RefAST(astFactory->make((new ANTLR_USE_NAMESPACE(antlr)ASTArray(5))->add(astFactory->create(REF,"REF"))->add(astFactory->create(INT,"-8"))->add(astFactory->create(INT,"-1"))->add(astFactory->create(INT,"-1"))->add(astFactory->create(INT,"-1"))));
#line 675 "CalcParser.cpp"
			currentAST.root = fullref_AST;
			if ( fullref_AST!=ANTLR_USE_NAMESPACE(antlr)nullAST &&
				fullref_AST->getFirstChild() != ANTLR_USE_NAMESPACE(antlr)nullAST )
				  currentAST.child = fullref_AST->getFirstChild();
			else
				currentAST.child = fullref_AST;
			currentAST.advanceChildToEnd();
		}
		break;
	}
	case LITERAL_nearest_left:
	{
		match(LITERAL_nearest_left);
		if ( inputState->guessing==0 ) {
			fullref_AST = ANTLR_USE_NAMESPACE(antlr)RefAST(currentAST.root);
#line 1038 "calc.g"
			fullref_AST = ANTLR_USE_NAMESPACE(antlr)RefAST(astFactory->make((new ANTLR_USE_NAMESPACE(antlr)ASTArray(5))->add(astFactory->create(REF,"REF"))->add(astFactory->create(INT,"-9"))->add(astFactory->create(INT,"-1"))->add(astFactory->create(INT,"-1"))->add(astFactory->create(INT,"-1"))));
#line 693 "CalcParser.cpp"
			currentAST.root = fullref_AST;
			if ( fullref_AST!=ANTLR_USE_NAMESPACE(antlr)nullAST &&
				fullref_AST->getFirstChild() != ANTLR_USE_NAMESPACE(antlr)nullAST )
				  currentAST.child = fullref_AST->getFirstChild();
			else
				currentAST.child = fullref_AST;
			currentAST.advanceChildToEnd();
		}
		break;
	}
	case LITERAL_nearest_right:
	{
		match(LITERAL_nearest_right);
		if ( inputState->guessing==0 ) {
			fullref_AST = ANTLR_USE_NAMESPACE(antlr)RefAST(currentAST.root);
#line 1040 "calc.g"
			fullref_AST = ANTLR_USE_NAMESPACE(antlr)RefAST(astFactory->make((new ANTLR_USE_NAMESPACE(antlr)ASTArray(5))->add(astFactory->create(REF,"REF"))->add(astFactory->create(INT,"-10"))->add(astFactory->create(INT,"-1"))->add(astFactory->create(INT,"-1"))->add(astFactory->create(INT,"-1"))));
#line 711 "CalcParser.cpp"
			currentAST.root = fullref_AST;
			if ( fullref_AST!=ANTLR_USE_NAMESPACE(antlr)nullAST &&
				fullref_AST->getFirstChild() != ANTLR_USE_NAMESPACE(antlr)nullAST )
				  currentAST.child = fullref_AST->getFirstChild();
			else
				currentAST.child = fullref_AST;
			currentAST.advanceChildToEnd();
		}
		break;
	}
	case LITERAL_nearest_up:
	{
		match(LITERAL_nearest_up);
		if ( inputState->guessing==0 ) {
			fullref_AST = ANTLR_USE_NAMESPACE(antlr)RefAST(currentAST.root);
#line 1042 "calc.g"
			fullref_AST = ANTLR_USE_NAMESPACE(antlr)RefAST(astFactory->make((new ANTLR_USE_NAMESPACE(antlr)ASTArray(5))->add(astFactory->create(REF,"REF"))->add(astFactory->create(INT,"-11"))->add(astFactory->create(INT,"-1"))->add(astFactory->create(INT,"-1"))->add(astFactory->create(INT,"-1"))));
#line 729 "CalcParser.cpp"
			currentAST.root = fullref_AST;
			if ( fullref_AST!=ANTLR_USE_NAMESPACE(antlr)nullAST &&
				fullref_AST->getFirstChild() != ANTLR_USE_NAMESPACE(antlr)nullAST )
				  currentAST.child = fullref_AST->getFirstChild();
			else
				currentAST.child = fullref_AST;
			currentAST.advanceChildToEnd();
		}
		break;
	}
	case LITERAL_nearest_down:
	{
		match(LITERAL_nearest_down);
		if ( inputState->guessing==0 ) {
			fullref_AST = ANTLR_USE_NAMESPACE(antlr)RefAST(currentAST.root);
#line 1044 "calc.g"
			fullref_AST = ANTLR_USE_NAMESPACE(antlr)RefAST(astFactory->make((new ANTLR_USE_NAMESPACE(antlr)ASTArray(5))->add(astFactory->create(REF,"REF"))->add(astFactory->create(INT,"-12"))->add(astFactory->create(INT,"-1"))->add(astFactory->create(INT,"-1"))->add(astFactory->create(INT,"-1"))));
#line 747 "CalcParser.cpp"
			currentAST.root = fullref_AST;
			if ( fullref_AST!=ANTLR_USE_NAMESPACE(antlr)nullAST &&
				fullref_AST->getFirstChild() != ANTLR_USE_NAMESPACE(antlr)nullAST )
				  currentAST.child = fullref_AST->getFirstChild();
			else
				currentAST.child = fullref_AST;
			currentAST.advanceChildToEnd();
		}
		break;
	}
	case LITERAL_EMPTY:
	{
		match(LITERAL_EMPTY);
		if ( inputState->guessing==0 ) {
			fullref_AST = ANTLR_USE_NAMESPACE(antlr)RefAST(currentAST.root);
#line 1046 "calc.g"
			fullref_AST = ANTLR_USE_NAMESPACE(antlr)RefAST(astFactory->make((new ANTLR_USE_NAMESPACE(antlr)ASTArray(5))->add(astFactory->create(REF,"REF"))->add(astFactory->create(INT,"-13"))->add(astFactory->create(INT,"-1"))->add(astFactory->create(INT,"-1"))->add(astFactory->create(INT,"-1"))));
#line 765 "CalcParser.cpp"
			currentAST.root = fullref_AST;
			if ( fullref_AST!=ANTLR_USE_NAMESPACE(antlr)nullAST &&
				fullref_AST->getFirstChild() != ANTLR_USE_NAMESPACE(antlr)nullAST )
				  currentAST.child = fullref_AST->getFirstChild();
			else
				currentAST.child = fullref_AST;
			currentAST.advanceChildToEnd();
		}
		break;
	}
	case LITERAL_nearest_in_dir:
	{
		match(LITERAL_nearest_in_dir);
		ANTLR_USE_NAMESPACE(antlr)RefAST tmp182_AST = ANTLR_USE_NAMESPACE(antlr)nullAST;
		if ( inputState->guessing == 0 ) {
			tmp182_AST = astFactory->create(LT(1));
		}
		match(LPAREN);
		fexpr();
		if (inputState->guessing==0) {
			dx_AST = returnAST;
		}
		ANTLR_USE_NAMESPACE(antlr)RefAST tmp183_AST = ANTLR_USE_NAMESPACE(antlr)nullAST;
		if ( inputState->guessing == 0 ) {
			tmp183_AST = astFactory->create(LT(1));
		}
		match(COMMA);
		fexpr();
		if (inputState->guessing==0) {
			dy_AST = returnAST;
		}
		ANTLR_USE_NAMESPACE(antlr)RefAST tmp184_AST = ANTLR_USE_NAMESPACE(antlr)nullAST;
		if ( inputState->guessing == 0 ) {
			tmp184_AST = astFactory->create(LT(1));
		}
		match(COMMA);
		fexpr();
		if (inputState->guessing==0) {
			ang_AST = returnAST;
		}
		ANTLR_USE_NAMESPACE(antlr)RefAST tmp185_AST = ANTLR_USE_NAMESPACE(antlr)nullAST;
		if ( inputState->guessing == 0 ) {
			tmp185_AST = astFactory->create(LT(1));
		}
		match(RPAREN);
		if ( inputState->guessing==0 ) {
			fullref_AST = ANTLR_USE_NAMESPACE(antlr)RefAST(currentAST.root);
#line 1048 "calc.g"
			fullref_AST = ANTLR_USE_NAMESPACE(antlr)RefAST(astFactory->make((new ANTLR_USE_NAMESPACE(antlr)ASTArray(5))->add(astFactory->create(REF,"REF"))->add(astFactory->create(INT,"-14"))->add(dx_AST)->add(dy_AST)->add(ang_AST)));
#line 815 "CalcParser.cpp"
			currentAST.root = fullref_AST;
			if ( fullref_AST!=ANTLR_USE_NAMESPACE(antlr)nullAST &&
				fullref_AST->getFirstChild() != ANTLR_USE_NAMESPACE(antlr)nullAST )
				  currentAST.child = fullref_AST->getFirstChild();
			else
				currentAST.child = fullref_AST;
			currentAST.advanceChildToEnd();
		}
		break;
	}
	case LITERAL_nearest_in_dir_second:
	{
		match(LITERAL_nearest_in_dir_second);
		ANTLR_USE_NAMESPACE(antlr)RefAST tmp187_AST = ANTLR_USE_NAMESPACE(antlr)nullAST;
		if ( inputState->guessing == 0 ) {
			tmp187_AST = astFactory->create(LT(1));
		}
		match(LPAREN);
		fexpr();
		if (inputState->guessing==0) {
			dxA_AST = returnAST;
		}
		ANTLR_USE_NAMESPACE(antlr)RefAST tmp188_AST = ANTLR_USE_NAMESPACE(antlr)nullAST;
		if ( inputState->guessing == 0 ) {
			tmp188_AST = astFactory->create(LT(1));
		}
		match(COMMA);
		fexpr();
		if (inputState->guessing==0) {
			dyA_AST = returnAST;
		}
		ANTLR_USE_NAMESPACE(antlr)RefAST tmp189_AST = ANTLR_USE_NAMESPACE(antlr)nullAST;
		if ( inputState->guessing == 0 ) {
			tmp189_AST = astFactory->create(LT(1));
		}
		match(COMMA);
		fexpr();
		if (inputState->guessing==0) {
			angA_AST = returnAST;
		}
		ANTLR_USE_NAMESPACE(antlr)RefAST tmp190_AST = ANTLR_USE_NAMESPACE(antlr)nullAST;
		if ( inputState->guessing == 0 ) {
			tmp190_AST = astFactory->create(LT(1));
		}
		match(RPAREN);
		if ( inputState->guessing==0 ) {
			fullref_AST = ANTLR_USE_NAMESPACE(antlr)RefAST(currentAST.root);
#line 1050 "calc.g"
			fullref_AST = ANTLR_USE_NAMESPACE(antlr)RefAST(astFactory->make((new ANTLR_USE_NAMESPACE(antlr)ASTArray(5))->add(astFactory->create(REF,"REF"))->add(astFactory->create(INT,"-15"))->add(dxA_AST)->add(dyA_AST)->add(angA_AST)));
#line 865 "CalcParser.cpp"
			currentAST.root = fullref_AST;
			if ( fullref_AST!=ANTLR_USE_NAMESPACE(antlr)nullAST &&
				fullref_AST->getFirstChild() != ANTLR_USE_NAMESPACE(antlr)nullAST )
				  currentAST.child = fullref_AST->getFirstChild();
			else
				currentAST.child = fullref_AST;
			currentAST.advanceChildToEnd();
		}
		break;
	}
	case LITERAL_nearest_in_dir_third:
	{
		match(LITERAL_nearest_in_dir_third);
		ANTLR_USE_NAMESPACE(antlr)RefAST tmp192_AST = ANTLR_USE_NAMESPACE(antlr)nullAST;
		if ( inputState->guessing == 0 ) {
			tmp192_AST = astFactory->create(LT(1));
		}
		match(LPAREN);
		fexpr();
		if (inputState->guessing==0) {
			dxB_AST = returnAST;
		}
		ANTLR_USE_NAMESPACE(antlr)RefAST tmp193_AST = ANTLR_USE_NAMESPACE(antlr)nullAST;
		if ( inputState->guessing == 0 ) {
			tmp193_AST = astFactory->create(LT(1));
		}
		match(COMMA);
		fexpr();
		if (inputState->guessing==0) {
			dyB_AST = returnAST;
		}
		ANTLR_USE_NAMESPACE(antlr)RefAST tmp194_AST = ANTLR_USE_NAMESPACE(antlr)nullAST;
		if ( inputState->guessing == 0 ) {
			tmp194_AST = astFactory->create(LT(1));
		}
		match(COMMA);
		fexpr();
		if (inputState->guessing==0) {
			angB_AST = returnAST;
		}
		ANTLR_USE_NAMESPACE(antlr)RefAST tmp195_AST = ANTLR_USE_NAMESPACE(antlr)nullAST;
		if ( inputState->guessing == 0 ) {
			tmp195_AST = astFactory->create(LT(1));
		}
		match(RPAREN);
		if ( inputState->guessing==0 ) {
			fullref_AST = ANTLR_USE_NAMESPACE(antlr)RefAST(currentAST.root);
#line 1052 "calc.g"
			fullref_AST = ANTLR_USE_NAMESPACE(antlr)RefAST(astFactory->make((new ANTLR_USE_NAMESPACE(antlr)ASTArray(5))->add(astFactory->create(REF,"REF"))->add(astFactory->create(INT,"-16"))->add(dxB_AST)->add(dyB_AST)->add(angB_AST)));
#line 915 "CalcParser.cpp"
			currentAST.root = fullref_AST;
			if ( fullref_AST!=ANTLR_USE_NAMESPACE(antlr)nullAST &&
				fullref_AST->getFirstChild() != ANTLR_USE_NAMESPACE(antlr)nullAST )
				  currentAST.child = fullref_AST->getFirstChild();
			else
				currentAST.child = fullref_AST;
			currentAST.advanceChildToEnd();
		}
		break;
	}
	case LITERAL_camera:
	{
		match(LITERAL_camera);
		if ( inputState->guessing==0 ) {
			fullref_AST = ANTLR_USE_NAMESPACE(antlr)RefAST(currentAST.root);
#line 1054 "calc.g"
			fullref_AST = ANTLR_USE_NAMESPACE(antlr)RefAST(astFactory->make((new ANTLR_USE_NAMESPACE(antlr)ASTArray(5))->add(astFactory->create(REF,"REF"))->add(astFactory->create(INT,"-17"))->add(astFactory->create(INT,"-1"))->add(astFactory->create(INT,"-1"))->add(astFactory->create(INT,"-1"))));
#line 933 "CalcParser.cpp"
			currentAST.root = fullref_AST;
			if ( fullref_AST!=ANTLR_USE_NAMESPACE(antlr)nullAST &&
				fullref_AST->getFirstChild() != ANTLR_USE_NAMESPACE(antlr)nullAST )
				  currentAST.child = fullref_AST->getFirstChild();
			else
				currentAST.child = fullref_AST;
			currentAST.advanceChildToEnd();
		}
		break;
	}
	case LITERAL_light_one:
	{
		match(LITERAL_light_one);
		if ( inputState->guessing==0 ) {
			fullref_AST = ANTLR_USE_NAMESPACE(antlr)RefAST(currentAST.root);
#line 1056 "calc.g"
			fullref_AST = ANTLR_USE_NAMESPACE(antlr)RefAST(astFactory->make((new ANTLR_USE_NAMESPACE(antlr)ASTArray(5))->add(astFactory->create(REF,"REF"))->add(astFactory->create(INT,"-18"))->add(astFactory->create(INT,"-1"))->add(astFactory->create(INT,"-1"))->add(astFactory->create(INT,"-1"))));
#line 951 "CalcParser.cpp"
			currentAST.root = fullref_AST;
			if ( fullref_AST!=ANTLR_USE_NAMESPACE(antlr)nullAST &&
				fullref_AST->getFirstChild() != ANTLR_USE_NAMESPACE(antlr)nullAST )
				  currentAST.child = fullref_AST->getFirstChild();
			else
				currentAST.child = fullref_AST;
			currentAST.advanceChildToEnd();
		}
		break;
	}
	case LITERAL_light_two:
	{
		match(LITERAL_light_two);
		if ( inputState->guessing==0 ) {
			fullref_AST = ANTLR_USE_NAMESPACE(antlr)RefAST(currentAST.root);
#line 1058 "calc.g"
			fullref_AST = ANTLR_USE_NAMESPACE(antlr)RefAST(astFactory->make((new ANTLR_USE_NAMESPACE(antlr)ASTArray(5))->add(astFactory->create(REF,"REF"))->add(astFactory->create(INT,"-19"))->add(astFactory->create(INT,"-1"))->add(astFactory->create(INT,"-1"))->add(astFactory->create(INT,"-1"))));
#line 969 "CalcParser.cpp"
			currentAST.root = fullref_AST;
			if ( fullref_AST!=ANTLR_USE_NAMESPACE(antlr)nullAST &&
				fullref_AST->getFirstChild() != ANTLR_USE_NAMESPACE(antlr)nullAST )
				  currentAST.child = fullref_AST->getFirstChild();
			else
				currentAST.child = fullref_AST;
			currentAST.advanceChildToEnd();
		}
		break;
	}
	case LITERAL_light_three:
	{
		match(LITERAL_light_three);
		if ( inputState->guessing==0 ) {
			fullref_AST = ANTLR_USE_NAMESPACE(antlr)RefAST(currentAST.root);
#line 1060 "calc.g"
			fullref_AST = ANTLR_USE_NAMESPACE(antlr)RefAST(astFactory->make((new ANTLR_USE_NAMESPACE(antlr)ASTArray(5))->add(astFactory->create(REF,"REF"))->add(astFactory->create(INT,"-20"))->add(astFactory->create(INT,"-1"))->add(astFactory->create(INT,"-1"))->add(astFactory->create(INT,"-1"))));
#line 987 "CalcParser.cpp"
			currentAST.root = fullref_AST;
			if ( fullref_AST!=ANTLR_USE_NAMESPACE(antlr)nullAST &&
				fullref_AST->getFirstChild() != ANTLR_USE_NAMESPACE(antlr)nullAST )
				  currentAST.child = fullref_AST->getFirstChild();
			else
				currentAST.child = fullref_AST;
			currentAST.advanceChildToEnd();
		}
		break;
	}
	default:
	{
		throw ANTLR_USE_NAMESPACE(antlr)NoViableAltException(LT(1), getFilename());
	}
	}
	returnAST = fullref_AST;
}

void CalcParser::lvalue() {
	returnAST = ANTLR_USE_NAMESPACE(antlr)nullAST;
	ANTLR_USE_NAMESPACE(antlr)ASTPair currentAST;
	ANTLR_USE_NAMESPACE(antlr)RefAST lvalue_AST = ANTLR_USE_NAMESPACE(antlr)nullAST;
	ANTLR_USE_NAMESPACE(antlr)RefAST a_AST = ANTLR_USE_NAMESPACE(antlr)nullAST;
	ANTLR_USE_NAMESPACE(antlr)RefAST l_AST = ANTLR_USE_NAMESPACE(antlr)nullAST;
	ANTLR_USE_NAMESPACE(antlr)RefAST b_AST = ANTLR_USE_NAMESPACE(antlr)nullAST;
	
	bool synPredMatched189 = false;
	if ((((LA(1) >= LITERAL_x && LA(1) <= LITERAL_mem)))) {
		int _m189 = mark();
		synPredMatched189 = true;
		inputState->guessing++;
		try {
			{
			attribute();
			localref();
			}
		}
		catch (ANTLR_USE_NAMESPACE(antlr)RecognitionException& pe) {
			synPredMatched189 = false;
		}
		rewind(_m189);
		inputState->guessing--;
	}
	if ( synPredMatched189 ) {
		{
		attribute();
		if (inputState->guessing==0) {
			a_AST = returnAST;
		}
		localref();
		if (inputState->guessing==0) {
			l_AST = returnAST;
		}
		}
		if ( inputState->guessing==0 ) {
			lvalue_AST = ANTLR_USE_NAMESPACE(antlr)RefAST(currentAST.root);
#line 982 "calc.g"
			lvalue_AST = ANTLR_USE_NAMESPACE(antlr)RefAST(astFactory->make((new ANTLR_USE_NAMESPACE(antlr)ASTArray(2))->add(a_AST)->add(l_AST)));
#line 1046 "CalcParser.cpp"
			currentAST.root = lvalue_AST;
			if ( lvalue_AST!=ANTLR_USE_NAMESPACE(antlr)nullAST &&
				lvalue_AST->getFirstChild() != ANTLR_USE_NAMESPACE(antlr)nullAST )
				  currentAST.child = lvalue_AST->getFirstChild();
			else
				currentAST.child = lvalue_AST;
			currentAST.advanceChildToEnd();
		}
	}
	else if (((LA(1) >= LITERAL_x && LA(1) <= LITERAL_mem))) {
		attribute();
		if (inputState->guessing==0) {
			b_AST = returnAST;
		}
		if ( inputState->guessing==0 ) {
			lvalue_AST = ANTLR_USE_NAMESPACE(antlr)RefAST(currentAST.root);
#line 984 "calc.g"
			lvalue_AST = ANTLR_USE_NAMESPACE(antlr)RefAST(astFactory->make((new ANTLR_USE_NAMESPACE(antlr)ASTArray(2))->add(b_AST)->add(ANTLR_USE_NAMESPACE(antlr)RefAST(astFactory->make((new ANTLR_USE_NAMESPACE(antlr)ASTArray(5))->add(astFactory->create(REF,"REF"))->add(astFactory->create(INT,"-1"))->add(astFactory->create(INT,"-1"))->add(astFactory->create(INT,"-1"))->add(astFactory->create(INT,"-1")))))));
#line 1065 "CalcParser.cpp"
			currentAST.root = lvalue_AST;
			if ( lvalue_AST!=ANTLR_USE_NAMESPACE(antlr)nullAST &&
				lvalue_AST->getFirstChild() != ANTLR_USE_NAMESPACE(antlr)nullAST )
				  currentAST.child = lvalue_AST->getFirstChild();
			else
				currentAST.child = lvalue_AST;
			currentAST.advanceChildToEnd();
		}
	}
	else if ((LA(1) == ID)) {
		ANTLR_USE_NAMESPACE(antlr)RefAST tmp200_AST = ANTLR_USE_NAMESPACE(antlr)nullAST;
		if ( inputState->guessing == 0 ) {
			tmp200_AST = astFactory->create(LT(1));
			astFactory->addASTChild(currentAST, tmp200_AST);
		}
		match(ID);
		lvalue_AST = currentAST.root;
	}
	else {
		throw ANTLR_USE_NAMESPACE(antlr)NoViableAltException(LT(1), getFilename());
	}
	
	returnAST = lvalue_AST;
}

void CalcParser::fexpr() {
	returnAST = ANTLR_USE_NAMESPACE(antlr)nullAST;
	ANTLR_USE_NAMESPACE(antlr)ASTPair currentAST;
	ANTLR_USE_NAMESPACE(antlr)RefAST fexpr_AST = ANTLR_USE_NAMESPACE(antlr)nullAST;
	
	logicexpr();
	if (inputState->guessing==0) {
		astFactory->addASTChild( currentAST, returnAST );
	}
	{ // ( ... )*
	for (;;) {
		if ((LA(1) == LITERAL_and || LA(1) == LITERAL_or)) {
			{
			switch ( LA(1)) {
			case LITERAL_or:
			{
				ANTLR_USE_NAMESPACE(antlr)RefAST tmp201_AST = ANTLR_USE_NAMESPACE(antlr)nullAST;
				if ( inputState->guessing == 0 ) {
					tmp201_AST = astFactory->create(LT(1));
					astFactory->makeASTRoot(currentAST, tmp201_AST);
				}
				match(LITERAL_or);
				break;
			}
			case LITERAL_and:
			{
				ANTLR_USE_NAMESPACE(antlr)RefAST tmp202_AST = ANTLR_USE_NAMESPACE(antlr)nullAST;
				if ( inputState->guessing == 0 ) {
					tmp202_AST = astFactory->create(LT(1));
					astFactory->makeASTRoot(currentAST, tmp202_AST);
				}
				match(LITERAL_and);
				break;
			}
			default:
			{
				throw ANTLR_USE_NAMESPACE(antlr)NoViableAltException(LT(1), getFilename());
			}
			}
			}
			logicexpr();
			if (inputState->guessing==0) {
				astFactory->addASTChild( currentAST, returnAST );
			}
		}
		else {
			goto _loop206;
		}
		
	}
	_loop206:;
	} // ( ... )*
	fexpr_AST = currentAST.root;
	returnAST = fexpr_AST;
}

void CalcParser::ref() {
	returnAST = ANTLR_USE_NAMESPACE(antlr)nullAST;
	ANTLR_USE_NAMESPACE(antlr)ASTPair currentAST;
	ANTLR_USE_NAMESPACE(antlr)RefAST ref_AST = ANTLR_USE_NAMESPACE(antlr)nullAST;
	ANTLR_USE_NAMESPACE(antlr)RefAST l_AST = ANTLR_USE_NAMESPACE(antlr)nullAST;
	ANTLR_USE_NAMESPACE(antlr)RefAST ll_AST = ANTLR_USE_NAMESPACE(antlr)nullAST;
	
	bool synPredMatched200 = false;
	if (((_tokenSet_2.member(LA(1))))) {
		int _m200 = mark();
		synPredMatched200 = true;
		inputState->guessing++;
		try {
			{
			fullref();
			}
		}
		catch (ANTLR_USE_NAMESPACE(antlr)RecognitionException& pe) {
			synPredMatched200 = false;
		}
		rewind(_m200);
		inputState->guessing--;
	}
	if ( synPredMatched200 ) {
		fullref();
		if (inputState->guessing==0) {
			l_AST = returnAST;
		}
		if ( inputState->guessing==0 ) {
			ref_AST = ANTLR_USE_NAMESPACE(antlr)RefAST(currentAST.root);
#line 1066 "calc.g"
			ref_AST = l_AST;
#line 1179 "CalcParser.cpp"
			currentAST.root = ref_AST;
			if ( ref_AST!=ANTLR_USE_NAMESPACE(antlr)nullAST &&
				ref_AST->getFirstChild() != ANTLR_USE_NAMESPACE(antlr)nullAST )
				  currentAST.child = ref_AST->getFirstChild();
			else
				currentAST.child = ref_AST;
			currentAST.advanceChildToEnd();
		}
	}
	else {
		bool synPredMatched202 = false;
		if (((_tokenSet_3.member(LA(1))))) {
			int _m202 = mark();
			synPredMatched202 = true;
			inputState->guessing++;
			try {
				{
				localref();
				}
			}
			catch (ANTLR_USE_NAMESPACE(antlr)RecognitionException& pe) {
				synPredMatched202 = false;
			}
			rewind(_m202);
			inputState->guessing--;
		}
		if ( synPredMatched202 ) {
			localref();
			if (inputState->guessing==0) {
				ll_AST = returnAST;
			}
			if ( inputState->guessing==0 ) {
				ref_AST = ANTLR_USE_NAMESPACE(antlr)RefAST(currentAST.root);
#line 1069 "calc.g"
				ref_AST = ll_AST;
#line 1215 "CalcParser.cpp"
				currentAST.root = ref_AST;
				if ( ref_AST!=ANTLR_USE_NAMESPACE(antlr)nullAST &&
					ref_AST->getFirstChild() != ANTLR_USE_NAMESPACE(antlr)nullAST )
					  currentAST.child = ref_AST->getFirstChild();
				else
					currentAST.child = ref_AST;
				currentAST.advanceChildToEnd();
			}
		}
	else {
		throw ANTLR_USE_NAMESPACE(antlr)NoViableAltException(LT(1), getFilename());
	}
	}
	returnAST = ref_AST;
}

void CalcParser::localref() {
	returnAST = ANTLR_USE_NAMESPACE(antlr)nullAST;
	ANTLR_USE_NAMESPACE(antlr)ASTPair currentAST;
	ANTLR_USE_NAMESPACE(antlr)RefAST localref_AST = ANTLR_USE_NAMESPACE(antlr)nullAST;
	ANTLR_USE_NAMESPACE(antlr)RefToken  i1 = ANTLR_USE_NAMESPACE(antlr)nullToken;
	ANTLR_USE_NAMESPACE(antlr)RefAST i1_AST = ANTLR_USE_NAMESPACE(antlr)nullAST;
	
	switch ( LA(1)) {
	case INT:
	{
		i1 = LT(1);
		if ( inputState->guessing == 0 ) {
			i1_AST = astFactory->create(i1);
			astFactory->addASTChild(currentAST, i1_AST);
		}
		match(INT);
		if ( inputState->guessing==0 ) {
			localref_AST = ANTLR_USE_NAMESPACE(antlr)RefAST(currentAST.root);
#line 996 "calc.g"
			localref_AST = ANTLR_USE_NAMESPACE(antlr)RefAST(astFactory->make((new ANTLR_USE_NAMESPACE(antlr)ASTArray(5))->add(astFactory->create(REF,"REF"))->add(i1_AST)->add(astFactory->create(INT,"-1"))->add(astFactory->create(INT,"-1"))->add(astFactory->create(INT,"-1"))));
#line 1252 "CalcParser.cpp"
			currentAST.root = localref_AST;
			if ( localref_AST!=ANTLR_USE_NAMESPACE(antlr)nullAST &&
				localref_AST->getFirstChild() != ANTLR_USE_NAMESPACE(antlr)nullAST )
				  currentAST.child = localref_AST->getFirstChild();
			else
				currentAST.child = localref_AST;
			currentAST.advanceChildToEnd();
		}
		localref_AST = currentAST.root;
		break;
	}
	case LITERAL_me:
	{
		match(LITERAL_me);
		if ( inputState->guessing==0 ) {
			localref_AST = ANTLR_USE_NAMESPACE(antlr)RefAST(currentAST.root);
#line 998 "calc.g"
			localref_AST = ANTLR_USE_NAMESPACE(antlr)RefAST(astFactory->make((new ANTLR_USE_NAMESPACE(antlr)ASTArray(5))->add(astFactory->create(REF,"REF"))->add(astFactory->create(INT,"-1"))->add(astFactory->create(INT,"-1"))->add(astFactory->create(INT,"-1"))->add(astFactory->create(INT,"-1"))));
#line 1271 "CalcParser.cpp"
			currentAST.root = localref_AST;
			if ( localref_AST!=ANTLR_USE_NAMESPACE(antlr)nullAST &&
				localref_AST->getFirstChild() != ANTLR_USE_NAMESPACE(antlr)nullAST )
				  currentAST.child = localref_AST->getFirstChild();
			else
				currentAST.child = localref_AST;
			currentAST.advanceChildToEnd();
		}
		break;
	}
	case LITERAL_prev:
	{
		match(LITERAL_prev);
		if ( inputState->guessing==0 ) {
			localref_AST = ANTLR_USE_NAMESPACE(antlr)RefAST(currentAST.root);
#line 1000 "calc.g"
			localref_AST = ANTLR_USE_NAMESPACE(antlr)RefAST(astFactory->make((new ANTLR_USE_NAMESPACE(antlr)ASTArray(5))->add(astFactory->create(REF,"REF"))->add(astFactory->create(INT,"-4"))->add(astFactory->create(INT,"-1"))->add(astFactory->create(INT,"-1"))->add(astFactory->create(INT,"-1"))));
#line 1289 "CalcParser.cpp"
			currentAST.root = localref_AST;
			if ( localref_AST!=ANTLR_USE_NAMESPACE(antlr)nullAST &&
				localref_AST->getFirstChild() != ANTLR_USE_NAMESPACE(antlr)nullAST )
				  currentAST.child = localref_AST->getFirstChild();
			else
				currentAST.child = localref_AST;
			currentAST.advanceChildToEnd();
		}
		break;
	}
	case LITERAL_next:
	{
		match(LITERAL_next);
		if ( inputState->guessing==0 ) {
			localref_AST = ANTLR_USE_NAMESPACE(antlr)RefAST(currentAST.root);
#line 1002 "calc.g"
			localref_AST = ANTLR_USE_NAMESPACE(antlr)RefAST(astFactory->make((new ANTLR_USE_NAMESPACE(antlr)ASTArray(5))->add(astFactory->create(REF,"REF"))->add(astFactory->create(INT,"-5"))->add(astFactory->create(INT,"-1"))->add(astFactory->create(INT,"-1"))->add(astFactory->create(INT,"-1"))));
#line 1307 "CalcParser.cpp"
			currentAST.root = localref_AST;
			if ( localref_AST!=ANTLR_USE_NAMESPACE(antlr)nullAST &&
				localref_AST->getFirstChild() != ANTLR_USE_NAMESPACE(antlr)nullAST )
				  currentAST.child = localref_AST->getFirstChild();
			else
				currentAST.child = localref_AST;
			currentAST.advanceChildToEnd();
		}
		break;
	}
	case LITERAL_EMPTY:
	{
		match(LITERAL_EMPTY);
		if ( inputState->guessing==0 ) {
			localref_AST = ANTLR_USE_NAMESPACE(antlr)RefAST(currentAST.root);
#line 1004 "calc.g"
			localref_AST = ANTLR_USE_NAMESPACE(antlr)RefAST(astFactory->make((new ANTLR_USE_NAMESPACE(antlr)ASTArray(5))->add(astFactory->create(REF,"REF"))->add(astFactory->create(INT,"-13"))->add(astFactory->create(INT,"-1"))->add(astFactory->create(INT,"-1"))->add(astFactory->create(INT,"-1"))));
#line 1325 "CalcParser.cpp"
			currentAST.root = localref_AST;
			if ( localref_AST!=ANTLR_USE_NAMESPACE(antlr)nullAST &&
				localref_AST->getFirstChild() != ANTLR_USE_NAMESPACE(antlr)nullAST )
				  currentAST.child = localref_AST->getFirstChild();
			else
				currentAST.child = localref_AST;
			currentAST.advanceChildToEnd();
		}
		break;
	}
	case LITERAL_camera:
	{
		match(LITERAL_camera);
		if ( inputState->guessing==0 ) {
			localref_AST = ANTLR_USE_NAMESPACE(antlr)RefAST(currentAST.root);
#line 1006 "calc.g"
			localref_AST = ANTLR_USE_NAMESPACE(antlr)RefAST(astFactory->make((new ANTLR_USE_NAMESPACE(antlr)ASTArray(5))->add(astFactory->create(REF,"REF"))->add(astFactory->create(INT,"-17"))->add(astFactory->create(INT,"-1"))->add(astFactory->create(INT,"-1"))->add(astFactory->create(INT,"-1"))));
#line 1343 "CalcParser.cpp"
			currentAST.root = localref_AST;
			if ( localref_AST!=ANTLR_USE_NAMESPACE(antlr)nullAST &&
				localref_AST->getFirstChild() != ANTLR_USE_NAMESPACE(antlr)nullAST )
				  currentAST.child = localref_AST->getFirstChild();
			else
				currentAST.child = localref_AST;
			currentAST.advanceChildToEnd();
		}
		break;
	}
	case LITERAL_light_one:
	{
		match(LITERAL_light_one);
		if ( inputState->guessing==0 ) {
			localref_AST = ANTLR_USE_NAMESPACE(antlr)RefAST(currentAST.root);
#line 1008 "calc.g"
			localref_AST = ANTLR_USE_NAMESPACE(antlr)RefAST(astFactory->make((new ANTLR_USE_NAMESPACE(antlr)ASTArray(5))->add(astFactory->create(REF,"REF"))->add(astFactory->create(INT,"-18"))->add(astFactory->create(INT,"-1"))->add(astFactory->create(INT,"-1"))->add(astFactory->create(INT,"-1"))));
#line 1361 "CalcParser.cpp"
			currentAST.root = localref_AST;
			if ( localref_AST!=ANTLR_USE_NAMESPACE(antlr)nullAST &&
				localref_AST->getFirstChild() != ANTLR_USE_NAMESPACE(antlr)nullAST )
				  currentAST.child = localref_AST->getFirstChild();
			else
				currentAST.child = localref_AST;
			currentAST.advanceChildToEnd();
		}
		break;
	}
	case LITERAL_light_two:
	{
		match(LITERAL_light_two);
		if ( inputState->guessing==0 ) {
			localref_AST = ANTLR_USE_NAMESPACE(antlr)RefAST(currentAST.root);
#line 1010 "calc.g"
			localref_AST = ANTLR_USE_NAMESPACE(antlr)RefAST(astFactory->make((new ANTLR_USE_NAMESPACE(antlr)ASTArray(5))->add(astFactory->create(REF,"REF"))->add(astFactory->create(INT,"-19"))->add(astFactory->create(INT,"-1"))->add(astFactory->create(INT,"-1"))->add(astFactory->create(INT,"-1"))));
#line 1379 "CalcParser.cpp"
			currentAST.root = localref_AST;
			if ( localref_AST!=ANTLR_USE_NAMESPACE(antlr)nullAST &&
				localref_AST->getFirstChild() != ANTLR_USE_NAMESPACE(antlr)nullAST )
				  currentAST.child = localref_AST->getFirstChild();
			else
				currentAST.child = localref_AST;
			currentAST.advanceChildToEnd();
		}
		break;
	}
	case LITERAL_light_three:
	{
		match(LITERAL_light_three);
		if ( inputState->guessing==0 ) {
			localref_AST = ANTLR_USE_NAMESPACE(antlr)RefAST(currentAST.root);
#line 1012 "calc.g"
			localref_AST = ANTLR_USE_NAMESPACE(antlr)RefAST(astFactory->make((new ANTLR_USE_NAMESPACE(antlr)ASTArray(5))->add(astFactory->create(REF,"REF"))->add(astFactory->create(INT,"-20"))->add(astFactory->create(INT,"-1"))->add(astFactory->create(INT,"-1"))->add(astFactory->create(INT,"-1"))));
#line 1397 "CalcParser.cpp"
			currentAST.root = localref_AST;
			if ( localref_AST!=ANTLR_USE_NAMESPACE(antlr)nullAST &&
				localref_AST->getFirstChild() != ANTLR_USE_NAMESPACE(antlr)nullAST )
				  currentAST.child = localref_AST->getFirstChild();
			else
				currentAST.child = localref_AST;
			currentAST.advanceChildToEnd();
		}
		break;
	}
	case ID:
	{
		ANTLR_USE_NAMESPACE(antlr)RefAST tmp211_AST = ANTLR_USE_NAMESPACE(antlr)nullAST;
		if ( inputState->guessing == 0 ) {
			tmp211_AST = astFactory->create(LT(1));
			astFactory->addASTChild(currentAST, tmp211_AST);
		}
		match(ID);
		if ( inputState->guessing==0 ) {
#line 1014 "calc.g"
			//  std::cerr << "[DEBUG] localref is an ID :-)\n";
				
#line 1420 "CalcParser.cpp"
		}
		localref_AST = currentAST.root;
		break;
	}
	default:
	{
		throw ANTLR_USE_NAMESPACE(antlr)NoViableAltException(LT(1), getFilename());
	}
	}
	returnAST = localref_AST;
}

void CalcParser::attribute() {
	returnAST = ANTLR_USE_NAMESPACE(antlr)nullAST;
	ANTLR_USE_NAMESPACE(antlr)ASTPair currentAST;
	ANTLR_USE_NAMESPACE(antlr)RefAST attribute_AST = ANTLR_USE_NAMESPACE(antlr)nullAST;
	ANTLR_USE_NAMESPACE(antlr)RefToken  i = ANTLR_USE_NAMESPACE(antlr)nullToken;
	ANTLR_USE_NAMESPACE(antlr)RefAST i_AST = ANTLR_USE_NAMESPACE(antlr)nullAST;
	
	switch ( LA(1)) {
	case LITERAL_dx:
	{
		ANTLR_USE_NAMESPACE(antlr)RefAST tmp212_AST = ANTLR_USE_NAMESPACE(antlr)nullAST;
		if ( inputState->guessing == 0 ) {
			tmp212_AST = astFactory->create(LT(1));
			astFactory->addASTChild(currentAST, tmp212_AST);
		}
		match(LITERAL_dx);
		attribute_AST = currentAST.root;
		break;
	}
	case LITERAL_dy:
	{
		ANTLR_USE_NAMESPACE(antlr)RefAST tmp213_AST = ANTLR_USE_NAMESPACE(antlr)nullAST;
		if ( inputState->guessing == 0 ) {
			tmp213_AST = astFactory->create(LT(1));
			astFactory->addASTChild(currentAST, tmp213_AST);
		}
		match(LITERAL_dy);
		attribute_AST = currentAST.root;
		break;
	}
	case LITERAL_x:
	{
		ANTLR_USE_NAMESPACE(antlr)RefAST tmp214_AST = ANTLR_USE_NAMESPACE(antlr)nullAST;
		if ( inputState->guessing == 0 ) {
			tmp214_AST = astFactory->create(LT(1));
			astFactory->addASTChild(currentAST, tmp214_AST);
		}
		match(LITERAL_x);
		attribute_AST = currentAST.root;
		break;
	}
	case LITERAL_y:
	{
		ANTLR_USE_NAMESPACE(antlr)RefAST tmp215_AST = ANTLR_USE_NAMESPACE(antlr)nullAST;
		if ( inputState->guessing == 0 ) {
			tmp215_AST = astFactory->create(LT(1));
			astFactory->addASTChild(currentAST, tmp215_AST);
		}
		match(LITERAL_y);
		attribute_AST = currentAST.root;
		break;
	}
	case LITERAL_angle:
	{
		ANTLR_USE_NAMESPACE(antlr)RefAST tmp216_AST = ANTLR_USE_NAMESPACE(antlr)nullAST;
		if ( inputState->guessing == 0 ) {
			tmp216_AST = astFactory->create(LT(1));
			astFactory->addASTChild(currentAST, tmp216_AST);
		}
		match(LITERAL_angle);
		attribute_AST = currentAST.root;
		break;
	}
	case LITERAL_icon:
	{
		ANTLR_USE_NAMESPACE(antlr)RefAST tmp217_AST = ANTLR_USE_NAMESPACE(antlr)nullAST;
		if ( inputState->guessing == 0 ) {
			tmp217_AST = astFactory->create(LT(1));
			astFactory->addASTChild(currentAST, tmp217_AST);
		}
		match(LITERAL_icon);
		attribute_AST = currentAST.root;
		break;
	}
	case LITERAL_width:
	{
		ANTLR_USE_NAMESPACE(antlr)RefAST tmp218_AST = ANTLR_USE_NAMESPACE(antlr)nullAST;
		if ( inputState->guessing == 0 ) {
			tmp218_AST = astFactory->create(LT(1));
			astFactory->addASTChild(currentAST, tmp218_AST);
		}
		match(LITERAL_width);
		attribute_AST = currentAST.root;
		break;
	}
	case LITERAL_height:
	{
		ANTLR_USE_NAMESPACE(antlr)RefAST tmp219_AST = ANTLR_USE_NAMESPACE(antlr)nullAST;
		if ( inputState->guessing == 0 ) {
			tmp219_AST = astFactory->create(LT(1));
			astFactory->addASTChild(currentAST, tmp219_AST);
		}
		match(LITERAL_height);
		attribute_AST = currentAST.root;
		break;
	}
	case LITERAL_zoom:
	{
		ANTLR_USE_NAMESPACE(antlr)RefAST tmp220_AST = ANTLR_USE_NAMESPACE(antlr)nullAST;
		if ( inputState->guessing == 0 ) {
			tmp220_AST = astFactory->create(LT(1));
			astFactory->addASTChild(currentAST, tmp220_AST);
		}
		match(LITERAL_zoom);
		attribute_AST = currentAST.root;
		break;
	}
	case LITERAL_color:
	{
		ANTLR_USE_NAMESPACE(antlr)RefAST tmp221_AST = ANTLR_USE_NAMESPACE(antlr)nullAST;
		if ( inputState->guessing == 0 ) {
			tmp221_AST = astFactory->create(LT(1));
			astFactory->addASTChild(currentAST, tmp221_AST);
		}
		match(LITERAL_color);
		attribute_AST = currentAST.root;
		break;
	}
	case LITERAL_red:
	{
		ANTLR_USE_NAMESPACE(antlr)RefAST tmp222_AST = ANTLR_USE_NAMESPACE(antlr)nullAST;
		if ( inputState->guessing == 0 ) {
			tmp222_AST = astFactory->create(LT(1));
			astFactory->addASTChild(currentAST, tmp222_AST);
		}
		match(LITERAL_red);
		attribute_AST = currentAST.root;
		break;
	}
	case LITERAL_green:
	{
		ANTLR_USE_NAMESPACE(antlr)RefAST tmp223_AST = ANTLR_USE_NAMESPACE(antlr)nullAST;
		if ( inputState->guessing == 0 ) {
			tmp223_AST = astFactory->create(LT(1));
			astFactory->addASTChild(currentAST, tmp223_AST);
		}
		match(LITERAL_green);
		attribute_AST = currentAST.root;
		break;
	}
	case LITERAL_blue:
	{
		ANTLR_USE_NAMESPACE(antlr)RefAST tmp224_AST = ANTLR_USE_NAMESPACE(antlr)nullAST;
		if ( inputState->guessing == 0 ) {
			tmp224_AST = astFactory->create(LT(1));
			astFactory->addASTChild(currentAST, tmp224_AST);
		}
		match(LITERAL_blue);
		attribute_AST = currentAST.root;
		break;
	}
	case LITERAL_gray:
	{
		ANTLR_USE_NAMESPACE(antlr)RefAST tmp225_AST = ANTLR_USE_NAMESPACE(antlr)nullAST;
		if ( inputState->guessing == 0 ) {
			tmp225_AST = astFactory->create(LT(1));
			astFactory->addASTChild(currentAST, tmp225_AST);
		}
		match(LITERAL_gray);
		attribute_AST = currentAST.root;
		break;
	}
	case LITERAL_shockx:
	{
		ANTLR_USE_NAMESPACE(antlr)RefAST tmp226_AST = ANTLR_USE_NAMESPACE(antlr)nullAST;
		if ( inputState->guessing == 0 ) {
			tmp226_AST = astFactory->create(LT(1));
			astFactory->addASTChild(currentAST, tmp226_AST);
		}
		match(LITERAL_shockx);
		attribute_AST = currentAST.root;
		break;
	}
	case LITERAL_shocky:
	{
		ANTLR_USE_NAMESPACE(antlr)RefAST tmp227_AST = ANTLR_USE_NAMESPACE(antlr)nullAST;
		if ( inputState->guessing == 0 ) {
			tmp227_AST = astFactory->create(LT(1));
			astFactory->addASTChild(currentAST, tmp227_AST);
		}
		match(LITERAL_shocky);
		attribute_AST = currentAST.root;
		break;
	}
	case LITERAL_visible:
	{
		ANTLR_USE_NAMESPACE(antlr)RefAST tmp228_AST = ANTLR_USE_NAMESPACE(antlr)nullAST;
		if ( inputState->guessing == 0 ) {
			tmp228_AST = astFactory->create(LT(1));
			astFactory->addASTChild(currentAST, tmp228_AST);
		}
		match(LITERAL_visible);
		attribute_AST = currentAST.root;
		break;
	}
	case LITERAL_contact:
	{
		ANTLR_USE_NAMESPACE(antlr)RefAST tmp229_AST = ANTLR_USE_NAMESPACE(antlr)nullAST;
		if ( inputState->guessing == 0 ) {
			tmp229_AST = astFactory->create(LT(1));
			astFactory->addASTChild(currentAST, tmp229_AST);
		}
		match(LITERAL_contact);
		attribute_AST = currentAST.root;
		break;
	}
	case LITERAL_mem:
	{
		match(LITERAL_mem);
		i = LT(1);
		if ( inputState->guessing == 0 ) {
			i_AST = astFactory->create(i);
		}
		match(INT);
		if ( inputState->guessing==0 ) {
			attribute_AST = ANTLR_USE_NAMESPACE(antlr)RefAST(currentAST.root);
#line 991 "calc.g"
			attribute_AST = ANTLR_USE_NAMESPACE(antlr)RefAST(astFactory->make((new ANTLR_USE_NAMESPACE(antlr)ASTArray(1))->add(astFactory->create(LITERAL_mem,i->getText()))));
#line 1651 "CalcParser.cpp"
			currentAST.root = attribute_AST;
			if ( attribute_AST!=ANTLR_USE_NAMESPACE(antlr)nullAST &&
				attribute_AST->getFirstChild() != ANTLR_USE_NAMESPACE(antlr)nullAST )
				  currentAST.child = attribute_AST->getFirstChild();
			else
				currentAST.child = attribute_AST;
			currentAST.advanceChildToEnd();
		}
		break;
	}
	default:
	{
		throw ANTLR_USE_NAMESPACE(antlr)NoViableAltException(LT(1), getFilename());
	}
	}
	returnAST = attribute_AST;
}

void CalcParser::logicexpr() {
	returnAST = ANTLR_USE_NAMESPACE(antlr)nullAST;
	ANTLR_USE_NAMESPACE(antlr)ASTPair currentAST;
	ANTLR_USE_NAMESPACE(antlr)RefAST logicexpr_AST = ANTLR_USE_NAMESPACE(antlr)nullAST;
	
	bool synPredMatched210 = false;
	if (((_tokenSet_4.member(LA(1))))) {
		int _m210 = mark();
		synPredMatched210 = true;
		inputState->guessing++;
		try {
			{
			ref();
			{
			switch ( LA(1)) {
			case EQUAL:
			{
				match(EQUAL);
				break;
			}
			case NEQ:
			{
				match(NEQ);
				break;
			}
			default:
			{
				throw ANTLR_USE_NAMESPACE(antlr)NoViableAltException(LT(1), getFilename());
			}
			}
			}
			ref();
			}
		}
		catch (ANTLR_USE_NAMESPACE(antlr)RecognitionException& pe) {
			synPredMatched210 = false;
		}
		rewind(_m210);
		inputState->guessing--;
	}
	if ( synPredMatched210 ) {
		ref();
		if (inputState->guessing==0) {
			astFactory->addASTChild( currentAST, returnAST );
		}
		{
		switch ( LA(1)) {
		case EQUAL:
		{
			ANTLR_USE_NAMESPACE(antlr)RefAST tmp231_AST = ANTLR_USE_NAMESPACE(antlr)nullAST;
			if ( inputState->guessing == 0 ) {
				tmp231_AST = astFactory->create(LT(1));
				astFactory->makeASTRoot(currentAST, tmp231_AST);
			}
			match(EQUAL);
			break;
		}
		case NEQ:
		{
			ANTLR_USE_NAMESPACE(antlr)RefAST tmp232_AST = ANTLR_USE_NAMESPACE(antlr)nullAST;
			if ( inputState->guessing == 0 ) {
				tmp232_AST = astFactory->create(LT(1));
				astFactory->makeASTRoot(currentAST, tmp232_AST);
			}
			match(NEQ);
			break;
		}
		default:
		{
			throw ANTLR_USE_NAMESPACE(antlr)NoViableAltException(LT(1), getFilename());
		}
		}
		}
		ref();
		if (inputState->guessing==0) {
			astFactory->addASTChild( currentAST, returnAST );
		}
		if ( inputState->guessing==0 ) {
#line 1076 "calc.g"
			// std::cerr << "[DEBUG] Found a comparison between two refs\n";
				
#line 1751 "CalcParser.cpp"
		}
		logicexpr_AST = currentAST.root;
	}
	else if ((_tokenSet_5.member(LA(1)))) {
		addexpr();
		if (inputState->guessing==0) {
			astFactory->addASTChild( currentAST, returnAST );
		}
		{ // ( ... )*
		for (;;) {
			if (((LA(1) >= EQUAL && LA(1) <= LEQ))) {
				{
				switch ( LA(1)) {
				case EQUAL:
				{
					ANTLR_USE_NAMESPACE(antlr)RefAST tmp233_AST = ANTLR_USE_NAMESPACE(antlr)nullAST;
					if ( inputState->guessing == 0 ) {
						tmp233_AST = astFactory->create(LT(1));
						astFactory->makeASTRoot(currentAST, tmp233_AST);
					}
					match(EQUAL);
					break;
				}
				case GREATER:
				{
					ANTLR_USE_NAMESPACE(antlr)RefAST tmp234_AST = ANTLR_USE_NAMESPACE(antlr)nullAST;
					if ( inputState->guessing == 0 ) {
						tmp234_AST = astFactory->create(LT(1));
						astFactory->makeASTRoot(currentAST, tmp234_AST);
					}
					match(GREATER);
					break;
				}
				case GEQ:
				{
					ANTLR_USE_NAMESPACE(antlr)RefAST tmp235_AST = ANTLR_USE_NAMESPACE(antlr)nullAST;
					if ( inputState->guessing == 0 ) {
						tmp235_AST = astFactory->create(LT(1));
						astFactory->makeASTRoot(currentAST, tmp235_AST);
					}
					match(GEQ);
					break;
				}
				case LESS:
				{
					ANTLR_USE_NAMESPACE(antlr)RefAST tmp236_AST = ANTLR_USE_NAMESPACE(antlr)nullAST;
					if ( inputState->guessing == 0 ) {
						tmp236_AST = astFactory->create(LT(1));
						astFactory->makeASTRoot(currentAST, tmp236_AST);
					}
					match(LESS);
					break;
				}
				case LEQ:
				{
					ANTLR_USE_NAMESPACE(antlr)RefAST tmp237_AST = ANTLR_USE_NAMESPACE(antlr)nullAST;
					if ( inputState->guessing == 0 ) {
						tmp237_AST = astFactory->create(LT(1));
						astFactory->makeASTRoot(currentAST, tmp237_AST);
					}
					match(LEQ);
					break;
				}
				case NEQ:
				{
					ANTLR_USE_NAMESPACE(antlr)RefAST tmp238_AST = ANTLR_USE_NAMESPACE(antlr)nullAST;
					if ( inputState->guessing == 0 ) {
						tmp238_AST = astFactory->create(LT(1));
						astFactory->makeASTRoot(currentAST, tmp238_AST);
					}
					match(NEQ);
					break;
				}
				default:
				{
					throw ANTLR_USE_NAMESPACE(antlr)NoViableAltException(LT(1), getFilename());
				}
				}
				}
				addexpr();
				if (inputState->guessing==0) {
					astFactory->addASTChild( currentAST, returnAST );
				}
			}
			else {
				goto _loop214;
			}
			
		}
		_loop214:;
		} // ( ... )*
		logicexpr_AST = currentAST.root;
	}
	else {
		throw ANTLR_USE_NAMESPACE(antlr)NoViableAltException(LT(1), getFilename());
	}
	
	returnAST = logicexpr_AST;
}

void CalcParser::addexpr() {
	returnAST = ANTLR_USE_NAMESPACE(antlr)nullAST;
	ANTLR_USE_NAMESPACE(antlr)ASTPair currentAST;
	ANTLR_USE_NAMESPACE(antlr)RefAST addexpr_AST = ANTLR_USE_NAMESPACE(antlr)nullAST;
	
	mexpr();
	if (inputState->guessing==0) {
		astFactory->addASTChild( currentAST, returnAST );
	}
	{ // ( ... )*
	for (;;) {
		if ((LA(1) == PLUS || LA(1) == MINUS)) {
			{
			switch ( LA(1)) {
			case PLUS:
			{
				ANTLR_USE_NAMESPACE(antlr)RefAST tmp239_AST = ANTLR_USE_NAMESPACE(antlr)nullAST;
				if ( inputState->guessing == 0 ) {
					tmp239_AST = astFactory->create(LT(1));
					astFactory->makeASTRoot(currentAST, tmp239_AST);
				}
				match(PLUS);
				break;
			}
			case MINUS:
			{
				ANTLR_USE_NAMESPACE(antlr)RefAST tmp240_AST = ANTLR_USE_NAMESPACE(antlr)nullAST;
				if ( inputState->guessing == 0 ) {
					tmp240_AST = astFactory->create(LT(1));
					astFactory->makeASTRoot(currentAST, tmp240_AST);
				}
				match(MINUS);
				break;
			}
			default:
			{
				throw ANTLR_USE_NAMESPACE(antlr)NoViableAltException(LT(1), getFilename());
			}
			}
			}
			mexpr();
			if (inputState->guessing==0) {
				astFactory->addASTChild( currentAST, returnAST );
			}
		}
		else {
			goto _loop218;
		}
		
	}
	_loop218:;
	} // ( ... )*
	addexpr_AST = currentAST.root;
	returnAST = addexpr_AST;
}

void CalcParser::mexpr() {
	returnAST = ANTLR_USE_NAMESPACE(antlr)nullAST;
	ANTLR_USE_NAMESPACE(antlr)ASTPair currentAST;
	ANTLR_USE_NAMESPACE(antlr)RefAST mexpr_AST = ANTLR_USE_NAMESPACE(antlr)nullAST;
	
	atom();
	if (inputState->guessing==0) {
		astFactory->addASTChild( currentAST, returnAST );
	}
	{ // ( ... )*
	for (;;) {
		if ((LA(1) == STAR || LA(1) == DIV || LA(1) == LITERAL_mod)) {
			{
			switch ( LA(1)) {
			case STAR:
			{
				ANTLR_USE_NAMESPACE(antlr)RefAST tmp241_AST = ANTLR_USE_NAMESPACE(antlr)nullAST;
				if ( inputState->guessing == 0 ) {
					tmp241_AST = astFactory->create(LT(1));
					astFactory->makeASTRoot(currentAST, tmp241_AST);
				}
				match(STAR);
				break;
			}
			case DIV:
			{
				ANTLR_USE_NAMESPACE(antlr)RefAST tmp242_AST = ANTLR_USE_NAMESPACE(antlr)nullAST;
				if ( inputState->guessing == 0 ) {
					tmp242_AST = astFactory->create(LT(1));
					astFactory->makeASTRoot(currentAST, tmp242_AST);
				}
				match(DIV);
				break;
			}
			case LITERAL_mod:
			{
				ANTLR_USE_NAMESPACE(antlr)RefAST tmp243_AST = ANTLR_USE_NAMESPACE(antlr)nullAST;
				if ( inputState->guessing == 0 ) {
					tmp243_AST = astFactory->create(LT(1));
					astFactory->makeASTRoot(currentAST, tmp243_AST);
				}
				match(LITERAL_mod);
				break;
			}
			default:
			{
				throw ANTLR_USE_NAMESPACE(antlr)NoViableAltException(LT(1), getFilename());
			}
			}
			}
			atom();
			if (inputState->guessing==0) {
				astFactory->addASTChild( currentAST, returnAST );
			}
		}
		else {
			goto _loop222;
		}
		
	}
	_loop222:;
	} // ( ... )*
	mexpr_AST = currentAST.root;
	returnAST = mexpr_AST;
}

void CalcParser::atom() {
	returnAST = ANTLR_USE_NAMESPACE(antlr)nullAST;
	ANTLR_USE_NAMESPACE(antlr)ASTPair currentAST;
	ANTLR_USE_NAMESPACE(antlr)RefAST atom_AST = ANTLR_USE_NAMESPACE(antlr)nullAST;
	ANTLR_USE_NAMESPACE(antlr)RefAST a_AST = ANTLR_USE_NAMESPACE(antlr)nullAST;
	ANTLR_USE_NAMESPACE(antlr)RefAST r_AST = ANTLR_USE_NAMESPACE(antlr)nullAST;
	ANTLR_USE_NAMESPACE(antlr)RefAST a1_AST = ANTLR_USE_NAMESPACE(antlr)nullAST;
	
	switch ( LA(1)) {
	case PLUS:
	case MINUS:
	{
		{
		switch ( LA(1)) {
		case PLUS:
		{
			ANTLR_USE_NAMESPACE(antlr)RefAST tmp244_AST = ANTLR_USE_NAMESPACE(antlr)nullAST;
			if ( inputState->guessing == 0 ) {
				tmp244_AST = astFactory->create(LT(1));
				astFactory->makeASTRoot(currentAST, tmp244_AST);
			}
			match(PLUS);
			break;
		}
		case MINUS:
		{
			ANTLR_USE_NAMESPACE(antlr)RefAST tmp245_AST = ANTLR_USE_NAMESPACE(antlr)nullAST;
			if ( inputState->guessing == 0 ) {
				tmp245_AST = astFactory->create(LT(1));
				astFactory->makeASTRoot(currentAST, tmp245_AST);
			}
			match(MINUS);
			break;
		}
		default:
		{
			throw ANTLR_USE_NAMESPACE(antlr)NoViableAltException(LT(1), getFilename());
		}
		}
		}
		atom();
		if (inputState->guessing==0) {
			astFactory->addASTChild( currentAST, returnAST );
		}
		atom_AST = currentAST.root;
		break;
	}
	case FLOAT:
	case INT:
	{
		float_();
		if (inputState->guessing==0) {
			astFactory->addASTChild( currentAST, returnAST );
		}
		atom_AST = currentAST.root;
		break;
	}
	case LPAREN:
	{
		match(LPAREN);
		fexpr();
		if (inputState->guessing==0) {
			astFactory->addASTChild( currentAST, returnAST );
		}
		match(RPAREN);
		atom_AST = currentAST.root;
		break;
	}
	case LITERAL_PI:
	case LITERAL_pi:
	case LITERAL_Pi:
	{
		{
		switch ( LA(1)) {
		case LITERAL_PI:
		{
			match(LITERAL_PI);
			break;
		}
		case LITERAL_pi:
		{
			match(LITERAL_pi);
			break;
		}
		case LITERAL_Pi:
		{
			match(LITERAL_Pi);
			break;
		}
		default:
		{
			throw ANTLR_USE_NAMESPACE(antlr)NoViableAltException(LT(1), getFilename());
		}
		}
		}
		if ( inputState->guessing==0 ) {
			atom_AST = ANTLR_USE_NAMESPACE(antlr)RefAST(currentAST.root);
#line 1093 "calc.g"
			atom_AST =ANTLR_USE_NAMESPACE(antlr)RefAST(astFactory->make((new ANTLR_USE_NAMESPACE(antlr)ASTArray(1))->add(astFactory->create(FLOAT,"3.14159"))));
#line 2073 "CalcParser.cpp"
			currentAST.root = atom_AST;
			if ( atom_AST!=ANTLR_USE_NAMESPACE(antlr)nullAST &&
				atom_AST->getFirstChild() != ANTLR_USE_NAMESPACE(antlr)nullAST )
				  currentAST.child = atom_AST->getFirstChild();
			else
				currentAST.child = atom_AST;
			currentAST.advanceChildToEnd();
		}
		break;
	}
	case LITERAL_RED:
	{
		match(LITERAL_RED);
		if ( inputState->guessing==0 ) {
			atom_AST = ANTLR_USE_NAMESPACE(antlr)RefAST(currentAST.root);
#line 1094 "calc.g"
			atom_AST =ANTLR_USE_NAMESPACE(antlr)RefAST(astFactory->make((new ANTLR_USE_NAMESPACE(antlr)ASTArray(1))->add(astFactory->create(FLOAT,RED))));
#line 2091 "CalcParser.cpp"
			currentAST.root = atom_AST;
			if ( atom_AST!=ANTLR_USE_NAMESPACE(antlr)nullAST &&
				atom_AST->getFirstChild() != ANTLR_USE_NAMESPACE(antlr)nullAST )
				  currentAST.child = atom_AST->getFirstChild();
			else
				currentAST.child = atom_AST;
			currentAST.advanceChildToEnd();
		}
		break;
	}
	case LITERAL_GREEN:
	{
		match(LITERAL_GREEN);
		if ( inputState->guessing==0 ) {
			atom_AST = ANTLR_USE_NAMESPACE(antlr)RefAST(currentAST.root);
#line 1095 "calc.g"
			atom_AST =ANTLR_USE_NAMESPACE(antlr)RefAST(astFactory->make((new ANTLR_USE_NAMESPACE(antlr)ASTArray(1))->add(astFactory->create(FLOAT,GREEN))));
#line 2109 "CalcParser.cpp"
			currentAST.root = atom_AST;
			if ( atom_AST!=ANTLR_USE_NAMESPACE(antlr)nullAST &&
				atom_AST->getFirstChild() != ANTLR_USE_NAMESPACE(antlr)nullAST )
				  currentAST.child = atom_AST->getFirstChild();
			else
				currentAST.child = atom_AST;
			currentAST.advanceChildToEnd();
		}
		break;
	}
	case LITERAL_BLUE:
	{
		match(LITERAL_BLUE);
		if ( inputState->guessing==0 ) {
			atom_AST = ANTLR_USE_NAMESPACE(antlr)RefAST(currentAST.root);
#line 1096 "calc.g"
			atom_AST =ANTLR_USE_NAMESPACE(antlr)RefAST(astFactory->make((new ANTLR_USE_NAMESPACE(antlr)ASTArray(1))->add(astFactory->create(FLOAT,BLUE))));
#line 2127 "CalcParser.cpp"
			currentAST.root = atom_AST;
			if ( atom_AST!=ANTLR_USE_NAMESPACE(antlr)nullAST &&
				atom_AST->getFirstChild() != ANTLR_USE_NAMESPACE(antlr)nullAST )
				  currentAST.child = atom_AST->getFirstChild();
			else
				currentAST.child = atom_AST;
			currentAST.advanceChildToEnd();
		}
		break;
	}
	case LITERAL_YELLOW:
	{
		match(LITERAL_YELLOW);
		if ( inputState->guessing==0 ) {
			atom_AST = ANTLR_USE_NAMESPACE(antlr)RefAST(currentAST.root);
#line 1097 "calc.g"
			atom_AST =ANTLR_USE_NAMESPACE(antlr)RefAST(astFactory->make((new ANTLR_USE_NAMESPACE(antlr)ASTArray(1))->add(astFactory->create(FLOAT,YELLOW))));
#line 2145 "CalcParser.cpp"
			currentAST.root = atom_AST;
			if ( atom_AST!=ANTLR_USE_NAMESPACE(antlr)nullAST &&
				atom_AST->getFirstChild() != ANTLR_USE_NAMESPACE(antlr)nullAST )
				  currentAST.child = atom_AST->getFirstChild();
			else
				currentAST.child = atom_AST;
			currentAST.advanceChildToEnd();
		}
		break;
	}
	case LITERAL_CYAN:
	{
		match(LITERAL_CYAN);
		if ( inputState->guessing==0 ) {
			atom_AST = ANTLR_USE_NAMESPACE(antlr)RefAST(currentAST.root);
#line 1098 "calc.g"
			atom_AST =ANTLR_USE_NAMESPACE(antlr)RefAST(astFactory->make((new ANTLR_USE_NAMESPACE(antlr)ASTArray(1))->add(astFactory->create(FLOAT,CYAN))));
#line 2163 "CalcParser.cpp"
			currentAST.root = atom_AST;
			if ( atom_AST!=ANTLR_USE_NAMESPACE(antlr)nullAST &&
				atom_AST->getFirstChild() != ANTLR_USE_NAMESPACE(antlr)nullAST )
				  currentAST.child = atom_AST->getFirstChild();
			else
				currentAST.child = atom_AST;
			currentAST.advanceChildToEnd();
		}
		break;
	}
	case LITERAL_PURPLE:
	{
		match(LITERAL_PURPLE);
		if ( inputState->guessing==0 ) {
			atom_AST = ANTLR_USE_NAMESPACE(antlr)RefAST(currentAST.root);
#line 1099 "calc.g"
			atom_AST =ANTLR_USE_NAMESPACE(antlr)RefAST(astFactory->make((new ANTLR_USE_NAMESPACE(antlr)ASTArray(1))->add(astFactory->create(FLOAT,PURPLE))));
#line 2181 "CalcParser.cpp"
			currentAST.root = atom_AST;
			if ( atom_AST!=ANTLR_USE_NAMESPACE(antlr)nullAST &&
				atom_AST->getFirstChild() != ANTLR_USE_NAMESPACE(antlr)nullAST )
				  currentAST.child = atom_AST->getFirstChild();
			else
				currentAST.child = atom_AST;
			currentAST.advanceChildToEnd();
		}
		break;
	}
	case LITERAL_WHITE:
	{
		match(LITERAL_WHITE);
		if ( inputState->guessing==0 ) {
			atom_AST = ANTLR_USE_NAMESPACE(antlr)RefAST(currentAST.root);
#line 1100 "calc.g"
			atom_AST =ANTLR_USE_NAMESPACE(antlr)RefAST(astFactory->make((new ANTLR_USE_NAMESPACE(antlr)ASTArray(1))->add(astFactory->create(FLOAT,WHITE))));
#line 2199 "CalcParser.cpp"
			currentAST.root = atom_AST;
			if ( atom_AST!=ANTLR_USE_NAMESPACE(antlr)nullAST &&
				atom_AST->getFirstChild() != ANTLR_USE_NAMESPACE(antlr)nullAST )
				  currentAST.child = atom_AST->getFirstChild();
			else
				currentAST.child = atom_AST;
			currentAST.advanceChildToEnd();
		}
		break;
	}
	case LITERAL_BLACK:
	{
		match(LITERAL_BLACK);
		if ( inputState->guessing==0 ) {
			atom_AST = ANTLR_USE_NAMESPACE(antlr)RefAST(currentAST.root);
#line 1101 "calc.g"
			atom_AST =ANTLR_USE_NAMESPACE(antlr)RefAST(astFactory->make((new ANTLR_USE_NAMESPACE(antlr)ASTArray(1))->add(astFactory->create(FLOAT,BLACK))));
#line 2217 "CalcParser.cpp"
			currentAST.root = atom_AST;
			if ( atom_AST!=ANTLR_USE_NAMESPACE(antlr)nullAST &&
				atom_AST->getFirstChild() != ANTLR_USE_NAMESPACE(antlr)nullAST )
				  currentAST.child = atom_AST->getFirstChild();
			else
				currentAST.child = atom_AST;
			currentAST.advanceChildToEnd();
		}
		break;
	}
	case LITERAL_GRAY:
	{
		match(LITERAL_GRAY);
		if ( inputState->guessing==0 ) {
			atom_AST = ANTLR_USE_NAMESPACE(antlr)RefAST(currentAST.root);
#line 1102 "calc.g"
			atom_AST =ANTLR_USE_NAMESPACE(antlr)RefAST(astFactory->make((new ANTLR_USE_NAMESPACE(antlr)ASTArray(1))->add(astFactory->create(FLOAT,GRAY))));
#line 2235 "CalcParser.cpp"
			currentAST.root = atom_AST;
			if ( atom_AST!=ANTLR_USE_NAMESPACE(antlr)nullAST &&
				atom_AST->getFirstChild() != ANTLR_USE_NAMESPACE(antlr)nullAST )
				  currentAST.child = atom_AST->getFirstChild();
			else
				currentAST.child = atom_AST;
			currentAST.advanceChildToEnd();
		}
		break;
	}
	case LITERAL_ORANGE:
	{
		match(LITERAL_ORANGE);
		if ( inputState->guessing==0 ) {
			atom_AST = ANTLR_USE_NAMESPACE(antlr)RefAST(currentAST.root);
#line 1103 "calc.g"
			atom_AST =ANTLR_USE_NAMESPACE(antlr)RefAST(astFactory->make((new ANTLR_USE_NAMESPACE(antlr)ASTArray(1))->add(astFactory->create(FLOAT,ORANGE))));
#line 2253 "CalcParser.cpp"
			currentAST.root = atom_AST;
			if ( atom_AST!=ANTLR_USE_NAMESPACE(antlr)nullAST &&
				atom_AST->getFirstChild() != ANTLR_USE_NAMESPACE(antlr)nullAST )
				  currentAST.child = atom_AST->getFirstChild();
			else
				currentAST.child = atom_AST;
			currentAST.advanceChildToEnd();
		}
		break;
	}
	case LITERAL_sqrt:
	{
		ANTLR_USE_NAMESPACE(antlr)RefAST tmp261_AST = ANTLR_USE_NAMESPACE(antlr)nullAST;
		if ( inputState->guessing == 0 ) {
			tmp261_AST = astFactory->create(LT(1));
			astFactory->makeASTRoot(currentAST, tmp261_AST);
		}
		match(LITERAL_sqrt);
		match(LPAREN);
		fexpr();
		if (inputState->guessing==0) {
			astFactory->addASTChild( currentAST, returnAST );
		}
		match(RPAREN);
		atom_AST = currentAST.root;
		break;
	}
	case LITERAL_sqr:
	{
		ANTLR_USE_NAMESPACE(antlr)RefAST tmp264_AST = ANTLR_USE_NAMESPACE(antlr)nullAST;
		if ( inputState->guessing == 0 ) {
			tmp264_AST = astFactory->create(LT(1));
			astFactory->makeASTRoot(currentAST, tmp264_AST);
		}
		match(LITERAL_sqr);
		match(LPAREN);
		fexpr();
		if (inputState->guessing==0) {
			astFactory->addASTChild( currentAST, returnAST );
		}
		match(RPAREN);
		atom_AST = currentAST.root;
		break;
	}
	case LITERAL_abs:
	{
		ANTLR_USE_NAMESPACE(antlr)RefAST tmp267_AST = ANTLR_USE_NAMESPACE(antlr)nullAST;
		if ( inputState->guessing == 0 ) {
			tmp267_AST = astFactory->create(LT(1));
			astFactory->makeASTRoot(currentAST, tmp267_AST);
		}
		match(LITERAL_abs);
		match(LPAREN);
		fexpr();
		if (inputState->guessing==0) {
			astFactory->addASTChild( currentAST, returnAST );
		}
		match(RPAREN);
		atom_AST = currentAST.root;
		break;
	}
	case LITERAL_sin:
	{
		ANTLR_USE_NAMESPACE(antlr)RefAST tmp270_AST = ANTLR_USE_NAMESPACE(antlr)nullAST;
		if ( inputState->guessing == 0 ) {
			tmp270_AST = astFactory->create(LT(1));
			astFactory->makeASTRoot(currentAST, tmp270_AST);
		}
		match(LITERAL_sin);
		match(LPAREN);
		fexpr();
		if (inputState->guessing==0) {
			astFactory->addASTChild( currentAST, returnAST );
		}
		match(RPAREN);
		atom_AST = currentAST.root;
		break;
	}
	case LITERAL_cos:
	{
		ANTLR_USE_NAMESPACE(antlr)RefAST tmp273_AST = ANTLR_USE_NAMESPACE(antlr)nullAST;
		if ( inputState->guessing == 0 ) {
			tmp273_AST = astFactory->create(LT(1));
			astFactory->makeASTRoot(currentAST, tmp273_AST);
		}
		match(LITERAL_cos);
		match(LPAREN);
		fexpr();
		if (inputState->guessing==0) {
			astFactory->addASTChild( currentAST, returnAST );
		}
		match(RPAREN);
		atom_AST = currentAST.root;
		break;
	}
	case LITERAL_tan:
	{
		ANTLR_USE_NAMESPACE(antlr)RefAST tmp276_AST = ANTLR_USE_NAMESPACE(antlr)nullAST;
		if ( inputState->guessing == 0 ) {
			tmp276_AST = astFactory->create(LT(1));
			astFactory->makeASTRoot(currentAST, tmp276_AST);
		}
		match(LITERAL_tan);
		match(LPAREN);
		fexpr();
		if (inputState->guessing==0) {
			astFactory->addASTChild( currentAST, returnAST );
		}
		match(RPAREN);
		atom_AST = currentAST.root;
		break;
	}
	case LITERAL_acs:
	{
		ANTLR_USE_NAMESPACE(antlr)RefAST tmp279_AST = ANTLR_USE_NAMESPACE(antlr)nullAST;
		if ( inputState->guessing == 0 ) {
			tmp279_AST = astFactory->create(LT(1));
			astFactory->makeASTRoot(currentAST, tmp279_AST);
		}
		match(LITERAL_acs);
		match(LPAREN);
		fexpr();
		if (inputState->guessing==0) {
			astFactory->addASTChild( currentAST, returnAST );
		}
		match(RPAREN);
		atom_AST = currentAST.root;
		break;
	}
	case LITERAL_asn:
	{
		ANTLR_USE_NAMESPACE(antlr)RefAST tmp282_AST = ANTLR_USE_NAMESPACE(antlr)nullAST;
		if ( inputState->guessing == 0 ) {
			tmp282_AST = astFactory->create(LT(1));
			astFactory->makeASTRoot(currentAST, tmp282_AST);
		}
		match(LITERAL_asn);
		match(LPAREN);
		fexpr();
		if (inputState->guessing==0) {
			astFactory->addASTChild( currentAST, returnAST );
		}
		match(RPAREN);
		atom_AST = currentAST.root;
		break;
	}
	case LITERAL_exp:
	{
		ANTLR_USE_NAMESPACE(antlr)RefAST tmp285_AST = ANTLR_USE_NAMESPACE(antlr)nullAST;
		if ( inputState->guessing == 0 ) {
			tmp285_AST = astFactory->create(LT(1));
			astFactory->makeASTRoot(currentAST, tmp285_AST);
		}
		match(LITERAL_exp);
		match(LPAREN);
		fexpr();
		if (inputState->guessing==0) {
			astFactory->addASTChild( currentAST, returnAST );
		}
		match(RPAREN);
		atom_AST = currentAST.root;
		break;
	}
	case LITERAL_log:
	{
		ANTLR_USE_NAMESPACE(antlr)RefAST tmp288_AST = ANTLR_USE_NAMESPACE(antlr)nullAST;
		if ( inputState->guessing == 0 ) {
			tmp288_AST = astFactory->create(LT(1));
			astFactory->makeASTRoot(currentAST, tmp288_AST);
		}
		match(LITERAL_log);
		match(LPAREN);
		fexpr();
		if (inputState->guessing==0) {
			astFactory->addASTChild( currentAST, returnAST );
		}
		match(RPAREN);
		atom_AST = currentAST.root;
		break;
	}
	case LITERAL_rnd:
	{
		ANTLR_USE_NAMESPACE(antlr)RefAST tmp291_AST = ANTLR_USE_NAMESPACE(antlr)nullAST;
		if ( inputState->guessing == 0 ) {
			tmp291_AST = astFactory->create(LT(1));
			astFactory->makeASTRoot(currentAST, tmp291_AST);
		}
		match(LITERAL_rnd);
		atom_AST = currentAST.root;
		break;
	}
	case LITERAL_srnd:
	{
		ANTLR_USE_NAMESPACE(antlr)RefAST tmp292_AST = ANTLR_USE_NAMESPACE(antlr)nullAST;
		if ( inputState->guessing == 0 ) {
			tmp292_AST = astFactory->create(LT(1));
			astFactory->makeASTRoot(currentAST, tmp292_AST);
		}
		match(LITERAL_srnd);
		atom_AST = currentAST.root;
		break;
	}
	case LITERAL_clic:
	{
		ANTLR_USE_NAMESPACE(antlr)RefAST tmp293_AST = ANTLR_USE_NAMESPACE(antlr)nullAST;
		if ( inputState->guessing == 0 ) {
			tmp293_AST = astFactory->create(LT(1));
			astFactory->makeASTRoot(currentAST, tmp293_AST);
		}
		match(LITERAL_clic);
		atom_AST = currentAST.root;
		break;
	}
	case LITERAL_click:
	{
		ANTLR_USE_NAMESPACE(antlr)RefAST tmp294_AST = ANTLR_USE_NAMESPACE(antlr)nullAST;
		if ( inputState->guessing == 0 ) {
			tmp294_AST = astFactory->create(LT(1));
			astFactory->makeASTRoot(currentAST, tmp294_AST);
		}
		match(LITERAL_click);
		atom_AST = currentAST.root;
		break;
	}
	case LITERAL_unclick:
	{
		ANTLR_USE_NAMESPACE(antlr)RefAST tmp295_AST = ANTLR_USE_NAMESPACE(antlr)nullAST;
		if ( inputState->guessing == 0 ) {
			tmp295_AST = astFactory->create(LT(1));
			astFactory->makeASTRoot(currentAST, tmp295_AST);
		}
		match(LITERAL_unclick);
		atom_AST = currentAST.root;
		break;
	}
	case LITERAL_clicked:
	{
		ANTLR_USE_NAMESPACE(antlr)RefAST tmp296_AST = ANTLR_USE_NAMESPACE(antlr)nullAST;
		if ( inputState->guessing == 0 ) {
			tmp296_AST = astFactory->create(LT(1));
			astFactory->makeASTRoot(currentAST, tmp296_AST);
		}
		match(LITERAL_clicked);
		atom_AST = currentAST.root;
		break;
	}
	case LITERAL_key_left:
	{
		ANTLR_USE_NAMESPACE(antlr)RefAST tmp297_AST = ANTLR_USE_NAMESPACE(antlr)nullAST;
		if ( inputState->guessing == 0 ) {
			tmp297_AST = astFactory->create(LT(1));
			astFactory->makeASTRoot(currentAST, tmp297_AST);
		}
		match(LITERAL_key_left);
		atom_AST = currentAST.root;
		break;
	}
	case LITERAL_key_right:
	{
		ANTLR_USE_NAMESPACE(antlr)RefAST tmp298_AST = ANTLR_USE_NAMESPACE(antlr)nullAST;
		if ( inputState->guessing == 0 ) {
			tmp298_AST = astFactory->create(LT(1));
			astFactory->makeASTRoot(currentAST, tmp298_AST);
		}
		match(LITERAL_key_right);
		atom_AST = currentAST.root;
		break;
	}
	case LITERAL_key_up:
	{
		ANTLR_USE_NAMESPACE(antlr)RefAST tmp299_AST = ANTLR_USE_NAMESPACE(antlr)nullAST;
		if ( inputState->guessing == 0 ) {
			tmp299_AST = astFactory->create(LT(1));
			astFactory->makeASTRoot(currentAST, tmp299_AST);
		}
		match(LITERAL_key_up);
		atom_AST = currentAST.root;
		break;
	}
	case LITERAL_key_down:
	{
		ANTLR_USE_NAMESPACE(antlr)RefAST tmp300_AST = ANTLR_USE_NAMESPACE(antlr)nullAST;
		if ( inputState->guessing == 0 ) {
			tmp300_AST = astFactory->create(LT(1));
			astFactory->makeASTRoot(currentAST, tmp300_AST);
		}
		match(LITERAL_key_down);
		atom_AST = currentAST.root;
		break;
	}
	case LITERAL_key_space:
	{
		ANTLR_USE_NAMESPACE(antlr)RefAST tmp301_AST = ANTLR_USE_NAMESPACE(antlr)nullAST;
		if ( inputState->guessing == 0 ) {
			tmp301_AST = astFactory->create(LT(1));
			astFactory->makeASTRoot(currentAST, tmp301_AST);
		}
		match(LITERAL_key_space);
		atom_AST = currentAST.root;
		break;
	}
	case LITERAL_ang:
	{
		ANTLR_USE_NAMESPACE(antlr)RefAST tmp302_AST = ANTLR_USE_NAMESPACE(antlr)nullAST;
		if ( inputState->guessing == 0 ) {
			tmp302_AST = astFactory->create(LT(1));
			astFactory->makeASTRoot(currentAST, tmp302_AST);
		}
		match(LITERAL_ang);
		match(LPAREN);
		fexpr();
		if (inputState->guessing==0) {
			astFactory->addASTChild( currentAST, returnAST );
		}
		match(COMMA);
		fexpr();
		if (inputState->guessing==0) {
			astFactory->addASTChild( currentAST, returnAST );
		}
		match(RPAREN);
		atom_AST = currentAST.root;
		break;
	}
	case LITERAL_min:
	{
		ANTLR_USE_NAMESPACE(antlr)RefAST tmp306_AST = ANTLR_USE_NAMESPACE(antlr)nullAST;
		if ( inputState->guessing == 0 ) {
			tmp306_AST = astFactory->create(LT(1));
			astFactory->makeASTRoot(currentAST, tmp306_AST);
		}
		match(LITERAL_min);
		match(LPAREN);
		fexpr();
		if (inputState->guessing==0) {
			astFactory->addASTChild( currentAST, returnAST );
		}
		match(COMMA);
		fexpr();
		if (inputState->guessing==0) {
			astFactory->addASTChild( currentAST, returnAST );
		}
		match(RPAREN);
		atom_AST = currentAST.root;
		break;
	}
	case LITERAL_max:
	{
		ANTLR_USE_NAMESPACE(antlr)RefAST tmp310_AST = ANTLR_USE_NAMESPACE(antlr)nullAST;
		if ( inputState->guessing == 0 ) {
			tmp310_AST = astFactory->create(LT(1));
			astFactory->makeASTRoot(currentAST, tmp310_AST);
		}
		match(LITERAL_max);
		match(LPAREN);
		fexpr();
		if (inputState->guessing==0) {
			astFactory->addASTChild( currentAST, returnAST );
		}
		match(COMMA);
		fexpr();
		if (inputState->guessing==0) {
			astFactory->addASTChild( currentAST, returnAST );
		}
		match(RPAREN);
		atom_AST = currentAST.root;
		break;
	}
	case LITERAL_int:
	{
		ANTLR_USE_NAMESPACE(antlr)RefAST tmp314_AST = ANTLR_USE_NAMESPACE(antlr)nullAST;
		if ( inputState->guessing == 0 ) {
			tmp314_AST = astFactory->create(LT(1));
			astFactory->makeASTRoot(currentAST, tmp314_AST);
		}
		match(LITERAL_int);
		match(LPAREN);
		fexpr();
		if (inputState->guessing==0) {
			astFactory->addASTChild( currentAST, returnAST );
		}
		match(RPAREN);
		atom_AST = currentAST.root;
		break;
	}
	case LITERAL_frac:
	{
		ANTLR_USE_NAMESPACE(antlr)RefAST tmp317_AST = ANTLR_USE_NAMESPACE(antlr)nullAST;
		if ( inputState->guessing == 0 ) {
			tmp317_AST = astFactory->create(LT(1));
			astFactory->makeASTRoot(currentAST, tmp317_AST);
		}
		match(LITERAL_frac);
		match(LPAREN);
		fexpr();
		if (inputState->guessing==0) {
			astFactory->addASTChild( currentAST, returnAST );
		}
		match(RPAREN);
		atom_AST = currentAST.root;
		break;
	}
	case LITERAL_sgn:
	{
		ANTLR_USE_NAMESPACE(antlr)RefAST tmp320_AST = ANTLR_USE_NAMESPACE(antlr)nullAST;
		if ( inputState->guessing == 0 ) {
			tmp320_AST = astFactory->create(LT(1));
			astFactory->makeASTRoot(currentAST, tmp320_AST);
		}
		match(LITERAL_sgn);
		match(LPAREN);
		fexpr();
		if (inputState->guessing==0) {
			astFactory->addASTChild( currentAST, returnAST );
		}
		match(RPAREN);
		atom_AST = currentAST.root;
		break;
	}
	case LITERAL_norm:
	{
		ANTLR_USE_NAMESPACE(antlr)RefAST tmp323_AST = ANTLR_USE_NAMESPACE(antlr)nullAST;
		if ( inputState->guessing == 0 ) {
			tmp323_AST = astFactory->create(LT(1));
			astFactory->makeASTRoot(currentAST, tmp323_AST);
		}
		match(LITERAL_norm);
		match(LPAREN);
		fexpr();
		if (inputState->guessing==0) {
			astFactory->addASTChild( currentAST, returnAST );
		}
		match(COMMA);
		fexpr();
		if (inputState->guessing==0) {
			astFactory->addASTChild( currentAST, returnAST );
		}
		match(RPAREN);
		atom_AST = currentAST.root;
		break;
	}
	case LITERAL_dist:
	{
		ANTLR_USE_NAMESPACE(antlr)RefAST tmp327_AST = ANTLR_USE_NAMESPACE(antlr)nullAST;
		if ( inputState->guessing == 0 ) {
			tmp327_AST = astFactory->create(LT(1));
			astFactory->makeASTRoot(currentAST, tmp327_AST);
		}
		match(LITERAL_dist);
		match(LPAREN);
		ref();
		if (inputState->guessing==0) {
			astFactory->addASTChild( currentAST, returnAST );
		}
		match(COMMA);
		ref();
		if (inputState->guessing==0) {
			astFactory->addASTChild( currentAST, returnAST );
		}
		match(RPAREN);
		atom_AST = currentAST.root;
		break;
	}
	case LITERAL_t:
	{
		ANTLR_USE_NAMESPACE(antlr)RefAST tmp331_AST = ANTLR_USE_NAMESPACE(antlr)nullAST;
		if ( inputState->guessing == 0 ) {
			tmp331_AST = astFactory->create(LT(1));
			astFactory->makeASTRoot(currentAST, tmp331_AST);
		}
		match(LITERAL_t);
		atom_AST = currentAST.root;
		break;
	}
	case LITERAL_dt:
	{
		ANTLR_USE_NAMESPACE(antlr)RefAST tmp332_AST = ANTLR_USE_NAMESPACE(antlr)nullAST;
		if ( inputState->guessing == 0 ) {
			tmp332_AST = astFactory->create(LT(1));
			astFactory->makeASTRoot(currentAST, tmp332_AST);
		}
		match(LITERAL_dt);
		atom_AST = currentAST.root;
		break;
	}
	case ID:
	{
		ANTLR_USE_NAMESPACE(antlr)RefAST tmp333_AST = ANTLR_USE_NAMESPACE(antlr)nullAST;
		if ( inputState->guessing == 0 ) {
			tmp333_AST = astFactory->create(LT(1));
			astFactory->addASTChild(currentAST, tmp333_AST);
		}
		match(ID);
		atom_AST = currentAST.root;
		break;
	}
	default:
		bool synPredMatched226 = false;
		if ((((LA(1) >= LITERAL_x && LA(1) <= LITERAL_mem)))) {
			int _m226 = mark();
			synPredMatched226 = true;
			inputState->guessing++;
			try {
				{
				attribute();
				ref();
				}
			}
			catch (ANTLR_USE_NAMESPACE(antlr)RecognitionException& pe) {
				synPredMatched226 = false;
			}
			rewind(_m226);
			inputState->guessing--;
		}
		if ( synPredMatched226 ) {
			attribute();
			if (inputState->guessing==0) {
				a_AST = returnAST;
			}
			ref();
			if (inputState->guessing==0) {
				r_AST = returnAST;
			}
			if ( inputState->guessing==0 ) {
				atom_AST = ANTLR_USE_NAMESPACE(antlr)RefAST(currentAST.root);
#line 1090 "calc.g"
				atom_AST = ANTLR_USE_NAMESPACE(antlr)RefAST(astFactory->make((new ANTLR_USE_NAMESPACE(antlr)ASTArray(2))->add(a_AST)->add(r_AST)));
#line 2780 "CalcParser.cpp"
				currentAST.root = atom_AST;
				if ( atom_AST!=ANTLR_USE_NAMESPACE(antlr)nullAST &&
					atom_AST->getFirstChild() != ANTLR_USE_NAMESPACE(antlr)nullAST )
					  currentAST.child = atom_AST->getFirstChild();
				else
					currentAST.child = atom_AST;
				currentAST.advanceChildToEnd();
			}
		}
		else if (((LA(1) >= LITERAL_x && LA(1) <= LITERAL_mem))) {
			attribute();
			if (inputState->guessing==0) {
				a1_AST = returnAST;
			}
			if ( inputState->guessing==0 ) {
				atom_AST = ANTLR_USE_NAMESPACE(antlr)RefAST(currentAST.root);
#line 1091 "calc.g"
				atom_AST = ANTLR_USE_NAMESPACE(antlr)RefAST(astFactory->make((new ANTLR_USE_NAMESPACE(antlr)ASTArray(2))->add(a1_AST)->add(ANTLR_USE_NAMESPACE(antlr)RefAST(astFactory->make((new ANTLR_USE_NAMESPACE(antlr)ASTArray(5))->add(astFactory->create(REF,"REF"))->add(astFactory->create(INT,"-1"))->add(astFactory->create(INT,"-1"))->add(astFactory->create(INT,"-1"))->add(astFactory->create(INT,"-1")))))));
#line 2799 "CalcParser.cpp"
				currentAST.root = atom_AST;
				if ( atom_AST!=ANTLR_USE_NAMESPACE(antlr)nullAST &&
					atom_AST->getFirstChild() != ANTLR_USE_NAMESPACE(antlr)nullAST )
					  currentAST.child = atom_AST->getFirstChild();
				else
					currentAST.child = atom_AST;
				currentAST.advanceChildToEnd();
			}
		}
	else {
		throw ANTLR_USE_NAMESPACE(antlr)NoViableAltException(LT(1), getFilename());
	}
	}
	returnAST = atom_AST;
}

void CalcParser::float_() {
	returnAST = ANTLR_USE_NAMESPACE(antlr)nullAST;
	ANTLR_USE_NAMESPACE(antlr)ASTPair currentAST;
	ANTLR_USE_NAMESPACE(antlr)RefAST float__AST = ANTLR_USE_NAMESPACE(antlr)nullAST;
	
	switch ( LA(1)) {
	case FLOAT:
	{
		ANTLR_USE_NAMESPACE(antlr)RefAST tmp334_AST = ANTLR_USE_NAMESPACE(antlr)nullAST;
		if ( inputState->guessing == 0 ) {
			tmp334_AST = astFactory->create(LT(1));
			astFactory->addASTChild(currentAST, tmp334_AST);
		}
		match(FLOAT);
		float__AST = currentAST.root;
		break;
	}
	case INT:
	{
		ANTLR_USE_NAMESPACE(antlr)RefAST tmp335_AST = ANTLR_USE_NAMESPACE(antlr)nullAST;
		if ( inputState->guessing == 0 ) {
			tmp335_AST = astFactory->create(LT(1));
			astFactory->addASTChild(currentAST, tmp335_AST);
		}
		match(INT);
		float__AST = currentAST.root;
		break;
	}
	default:
	{
		throw ANTLR_USE_NAMESPACE(antlr)NoViableAltException(LT(1), getFilename());
	}
	}
	returnAST = float__AST;
}

void CalcParser::initializeASTFactory( ANTLR_USE_NAMESPACE(antlr)ASTFactory& factory )
{
	factory.setMaxNodeType(128);
}
const char* CalcParser::tokenNames[] = {
	"<0>",
	"EOF",
	"<2>",
	"NULL_TREE_LOOKAHEAD",
	"\"if\"",
	"\"stop\"",
	"\"start\"",
	"\"restart\"",
	"\"like\"",
	"\"move_to\"",
	"\"echo\"",
	"un mot",
	"':'",
	"\"trace\"",
	"REF",
	"\"x\"",
	"\"y\"",
	"\"dx\"",
	"\"dy\"",
	"\"angle\"",
	"\"icon\"",
	"\"color\"",
	"\"red\"",
	"\"green\"",
	"\"blue\"",
	"\"gray\"",
	"\"shockx\"",
	"\"shocky\"",
	"\"width\"",
	"\"height\"",
	"\"zoom\"",
	"\"visible\"",
	"\"contact\"",
	"\"mem\"",
	"'+'",
	"'-'",
	"'*'",
	"'/'",
	"FLOAT",
	"un nombre",
	"\"sqr\"",
	"\"sqrt\"",
	"\"abs\"",
	"\"sin\"",
	"\"cos\"",
	"\"tan\"",
	"\"acs\"",
	"\"asn\"",
	"\"exp\"",
	"\"log\"",
	"\"clic\"",
	"\"click\"",
	"\"unclick\"",
	"\"clicked\"",
	"\"key_left\"",
	"\"key_right\"",
	"\"key_up\"",
	"\"key_down\"",
	"\"key_space\"",
	"\"rnd\"",
	"\"srnd\"",
	"\"ang\"",
	"\"min\"",
	"\"max\"",
	"\"int\"",
	"\"frac\"",
	"\"sgn\"",
	"\"norm\"",
	"\"mod\"",
	"\"dist\"",
	"\"t\"",
	"\"dt\"",
	"'='",
	"'<>'",
	"'>'",
	"'>='",
	"'<'",
	"'<='",
	"\"and\"",
	"\"or\"",
	"fin de la ligne",
	"';'",
	"\"then\"",
	"\"else\"",
	"\"endif\"",
	"'('",
	"','",
	"')'",
	"\"me\"",
	"\"prev\"",
	"\"next\"",
	"\"EMPTY\"",
	"\"camera\"",
	"\"light_one\"",
	"\"light_two\"",
	"\"light_three\"",
	"'@'",
	"\"mouse\"",
	"\"collider\"",
	"\"nearest\"",
	"\"nearest_second\"",
	"\"nearest_third\"",
	"\"nearest_left\"",
	"\"nearest_right\"",
	"\"nearest_up\"",
	"\"nearest_down\"",
	"\"nearest_in_dir\"",
	"\"nearest_in_dir_second\"",
	"\"nearest_in_dir_third\"",
	"\"PI\"",
	"\"pi\"",
	"\"Pi\"",
	"\"RED\"",
	"\"GREEN\"",
	"\"BLUE\"",
	"\"YELLOW\"",
	"\"CYAN\"",
	"\"PURPLE\"",
	"\"WHITE\"",
	"\"BLACK\"",
	"\"GRAY\"",
	"\"ORANGE\"",
	"un commentaire",
	"des chiffres",
	"des lettres",
	"un attribut",
	"SYNONYMS",
	"FRENCH_VOCAB",
	"WS_",
	0
};

const unsigned long CalcParser::_tokenSet_0_data_[] = { 4294946800UL, 3UL, 196608UL, 0UL, 0UL, 0UL, 0UL, 0UL };
// "if" "stop" "start" "restart" "like" "move_to" "echo" ID "trace" "x" 
// "y" "dx" "dy" "angle" "icon" "color" "red" "green" "blue" "gray" "shockx" 
// "shocky" "width" "height" "zoom" "visible" "contact" "mem" NEWLINE SEMI 
const ANTLR_USE_NAMESPACE(antlr)BitSet CalcParser::_tokenSet_0(_tokenSet_0_data_,8);
const unsigned long CalcParser::_tokenSet_1_data_[] = { 4294936576UL, 3UL, 0UL, 0UL, 0UL, 0UL };
// ID "x" "y" "dx" "dy" "angle" "icon" "color" "red" "green" "blue" "gray" 
// "shockx" "shocky" "width" "height" "zoom" "visible" "contact" "mem" 
const ANTLR_USE_NAMESPACE(antlr)BitSet CalcParser::_tokenSet_1(_tokenSet_1_data_,6);
const unsigned long CalcParser::_tokenSet_2_data_[] = { 0UL, 128UL, 4278190080UL, 8190UL, 0UL, 0UL, 0UL, 0UL };
// INT "me" "prev" "next" "EMPTY" "camera" "light_one" "light_two" "light_three" 
// "mouse" "collider" "nearest" "nearest_second" "nearest_third" "nearest_left" 
// "nearest_right" "nearest_up" "nearest_down" "nearest_in_dir" "nearest_in_dir_second" 
// "nearest_in_dir_third" 
const ANTLR_USE_NAMESPACE(antlr)BitSet CalcParser::_tokenSet_2(_tokenSet_2_data_,8);
const unsigned long CalcParser::_tokenSet_3_data_[] = { 2048UL, 128UL, 4278190080UL, 0UL, 0UL, 0UL, 0UL, 0UL };
// ID INT "me" "prev" "next" "EMPTY" "camera" "light_one" "light_two" "light_three" 
const ANTLR_USE_NAMESPACE(antlr)BitSet CalcParser::_tokenSet_3(_tokenSet_3_data_,8);
const unsigned long CalcParser::_tokenSet_4_data_[] = { 2048UL, 128UL, 4278190080UL, 8190UL, 0UL, 0UL, 0UL, 0UL };
// ID INT "me" "prev" "next" "EMPTY" "camera" "light_one" "light_two" "light_three" 
// "mouse" "collider" "nearest" "nearest_second" "nearest_third" "nearest_left" 
// "nearest_right" "nearest_up" "nearest_down" "nearest_in_dir" "nearest_in_dir_second" 
// "nearest_in_dir_third" 
const ANTLR_USE_NAMESPACE(antlr)BitSet CalcParser::_tokenSet_4(_tokenSet_4_data_,8);
const unsigned long CalcParser::_tokenSet_5_data_[] = { 4294936576UL, 4294967247UL, 2097391UL, 67100672UL, 0UL, 0UL, 0UL, 0UL };
// ID "x" "y" "dx" "dy" "angle" "icon" "color" "red" "green" "blue" "gray" 
// "shockx" "shocky" "width" "height" "zoom" "visible" "contact" "mem" 
// PLUS MINUS FLOAT INT "sqr" "sqrt" "abs" "sin" "cos" "tan" "acs" "asn" 
// "exp" "log" "clic" "click" "unclick" "clicked" "key_left" "key_right" 
// "key_up" "key_down" "key_space" "rnd" "srnd" "ang" "min" "max" "int" 
// "frac" "sgn" "norm" "dist" "t" "dt" LPAREN "PI" "pi" "Pi" "RED" "GREEN" 
// "BLUE" "YELLOW" "CYAN" "PURPLE" "WHITE" "BLACK" "GRAY" "ORANGE" 
const ANTLR_USE_NAMESPACE(antlr)BitSet CalcParser::_tokenSet_5(_tokenSet_5_data_,8);


